#define _ASPLINUX_
#include <stdio.h>			/* */
#include <stdarg.h>			/* */
#include <string.h>			/* */
#include <malloc.h>			/* */
#include <stdlib.h>			/* */
#include <unistd.h>			/* */
#include <time.h>			/* */

#include <errno.h>			/* */
#include <ctype.h>			/* */
#include <fcntl.h>			/* */
#include <pwd.h>			/* */	
#include <setjmp.h>			/* */		
#include <signal.h>			/* */
#include <stdio.h>			/* */
#include <stdlib.h>			/* */
#include <string.h>			/* */
#include <syslog.h>			/* */
#include <termios.h>			/* */
#include <unistd.h>			/* */
#include <utmp.h>			/* */

#include <sys/errno.h>			/* */
#include <sys/file.h>			/* */
#include <sys/ioctl.h>			/* */
#include <sys/param.h>			/* */
#include <sys/resource.h>		/* */
#include <sys/stat.h>			/* */
#include <sys/time.h>			/* */
#include <sys/types.h>			/* */
#include <sys/utsname.h>		/* */	
#include <sys/wait.h>			/* */
#include <math.h>			/* */

#include "ustcio.hpp"

#define USTCIO_USAGE \
"USTCCAD 0.1 (c) 2006-2010 Dmitriy I.Cherkashin, www.ucrouter.ru\n"  \
"email: dch@ucrouter.ru , divch@users.sourceforge.net , dch@ucrouter.com\n"  \
"phone: +8-909-936-8809; ICQ: 474-363-900;\n"  \
"This is not public software, you can't use this library without\n"  \
"license agreement, which available via option --license\n"  \
"with noted above author. To see license agreement use:\n"  \
"ustc --license\n"  \
"  or\n"  \
"ustc --license-ru\n"  \
"  for russian license translation.\n"  \

#define USTCIO_LICENSE \
"USTCCAD 0.1 (c) 2006-2010 Dmitriy I.Cherkashin, www.ucrouter.ru\r\n"  \
"email: dch@ucrouter.ru , divch@users.sourceforge.net , dch@ucrouter.com\r\n"  \
"phone: +8-909-936-8809; ICQ: 474-363-900;\r\n"  \
"This library is free software with source codes\r\n"  \
"downloadable via internation communicational net.\r\n"  \
"If you have source codes of this software original or modified,\r\n"  \
"you must provide ability to free receive original source codes\r\n"  \
"of this software to another users even in internation communicational\r\n"  \
"net absense without any unusual additional payment exept\r\n" \
"downloading files from internation communicational net cost or\r\n" \
"mail cost.\r\n"

#define USTCIO_LICENSE_RU \
"USTCCAD 0.1 (c) 2006-2010  ., www.ucrouter.ru\r\n" \
" : dch@ucrouter.ru,divch@users.sourceforge.net,dch@ucrouter.com\r\n"  \
": +8-909-936-8809; ICQ: 474-363-900;\r\n" \
"     \r\n" \
"      \r\n" \
" .\r\n" \
"       \r\n" \
"  ,     \r\n" \
"     \r\n" \
"     \r\n" \
"      \r\n" \
"       \r\n" \
"    \r\n" \
"     .\r\n"
u_int8_t * ustcio_usage   = (u_int8_t *)USTCIO_USAGE;
u_int8_t * ustcio_license = (u_int8_t *)USTCIO_LICENSE;
/* read buffer from input file */
/* return (-1) - error, bytes count without additional spaces */
int ustc_read(void * buf, int len, u_int8_t * cut)
{
 if(ustc_fi == 0) {			/* null input file pointer */
    return(-1);
 }
 int cnt;				/* readed bytes */
 u_int8_t rch;				/* readed character */
 cnt = fread(& rch, 1, 1, ustc_fi);	/* read character */
 if(
    (cnt == 1) && 			/* character readed */
    (
     (rch == '\r') || 			/* readed cr or */
     (rch == '\n')			/* readed new line */
    )
 ) {
    while(1) {
        cnt = fread(& rch, 1, 1, ustc_fi); /* skip empty lines */
	if(
	    (cnt != 1) || 		/* character readed check */
	    (
	     (rch != '\r') && 		/* cr check */
	     (rch != '\n')		/* nl check */
	    )
	) {
	    { break; }
	}
    }    
 }
 u_int16_t pos;				/* destination position */
 u_int8_t lch;				/* previous character */
 pos = 0;				/* start destination position */
 lch = 0;				/* start character */
 while(cnt) {
    if(rch == '\t') {			/* horisontal tab check */
	rch = ' ';			/* readed character space */
    } else 
    if(rch == '\v') {			/* vertical tab check */
	rch = ' ';			/* readed character space */
    }
    if((rch == ' ') && (lch == ' ')) {  /* skip additional spaces */
	cnt = fread(& rch, 1, 1, ustc_fi);
	if((rch == '\r') || (rch == '\n')) {
	    { break; }			/* string terminator */
	} else {
	    { continue; }
	}
    }
    lch = rch;				/* character save */
    if(buf != 0) {
	if(pos < len) {
	    *((u_int8_t *)buf + pos) = rch; /* write character to buffer */
	}
    }
    pos += 1;				/* next buffer position */
    cnt = fread(& rch, 1, 1, ustc_fi);  /* read next character */
    if((rch == '\r') || (rch == '\n')) {
	{ break; }			/* string terminator */
    }
 }
 int rvl;
 rvl = pos;
 if(len == 0) {
    if(cut != 0) {
        *cut = 1;			/* write cuting */
    }
 } else {
    if(pos > len) {			/* string cutted check */
	if(cut != 0) {
	    *cut = 1;			/* write cuting */
	}
	pos = len - 1;			/* end buffer position */
    } else {				/* string not cutted */
	if(cut != 0) {
	    *cut = 0;
	}
    }
    *((u_int8_t *)buf + pos) = '\0';	/* write string terminator */
 }
#ifdef  __USTC_DEBUG__
 if(ustc_debug_mode > 0) {
    if(buf != 0) {
	ustc_printf("%s\r\n", (char *)buf);
    }
 }
#endif 						/* __USTC_DEBUG__ */
 return(rvl);
}
int ustc_cmp(void * buf, char * str, int *spos) /* string compare */
{
 if(buf == 0) {				/* null buffer pointer */
    return(0);
 }
 u_int16_t pos;				/* buffer position */
 if(spos == 0) {
    pos = 0;				/* clear buffer position */
 } else {
    pos = *spos;			/* read buffer position */
 }
 u_int8_t rch;				/* readed character */
 rch = *((u_int8_t *)buf + pos);	/* read character from buffer */
 pos += 1;				/* next buffer position */
 while((rch == '\t') || (rch == ' ') || (rch == '\v')) {
    rch = *((u_int8_t *)buf + pos);	/* read next character */
    pos += 1;				/* next buffer position */
 }
 if(rch == '\0') {			
/* string readed */
    if(*str == '\0') {
	if(spos != 0) {
	    *spos = pos;
	}
	return(1);			/* strings empty */
    } else {
	return(0);
    }
 }
 u_int8_t sch;				/* string character */
 u_int16_t tpos;			/* string position */
 tpos = 0;				/* start string position */
 sch = *(str + tpos);			/* read string character */
 tpos += 1;				/* next string position */
 while(sch != '\0') {
    if(rch != sch) {
	return(0);			/* string not equal */
    }
    sch = *(str + tpos);		/* read string character */
    tpos += 1;				/* next string position */
    rch = *((u_int8_t *)buf + pos);	/* read character from buffer */
    pos += 1;				/* next buffer position */
    if(rch == '\0') {
	if(sch == '\0') {
	    if(spos != 0) {
		*spos = pos;
	    }
	    return(1);
	} else {
	    return(0);			
	}
    }
 }
 if(spos != 0) {
    *spos = pos - 1;
 }
 if(
    (rch == ' ') || 			/* space */
    (rch == '\0')			/* null terminating string */
 ) {
    return(1);				/* string found */
 } else {
    return(0);
 }
}
int ustc_ncmp(void * buf,char * str,int *spos,int count,int unsen)
{
 if(buf == 0) {				/* null buffer pointer */
    return(0);
 }
 u_int16_t pos;				/* buffer position */
 if(spos == 0) {			/* buffer position pointer check */
    pos = 0;				/* clear buffer position */
 } else {
    pos = *spos;			/* read buffer position */
 }
 u_int8_t rch;				/* readed character */
 rch = *((u_int8_t *)buf + pos);	/* read character from buffer */
 pos += 1;				/* next buffer position */
 while(
    (rch == '\t') || 			/* horizontal tab check */
    (rch == ' ') || 			/* space character check */
    (rch == '\v')			/* vertical tab check */
 ) {
    rch = *((u_int8_t *)buf + pos);	/* read next character */
    pos += 1;				/* next buffer position */
 }
 if(rch == '\0') {			/* buffer empty check */
    if(count <= 0) {			/* compare length check */
	if(spos != 0) {			/* position buffer pointer check */
	    *spos = pos;		/* position write */
	}
	return(1);			/* strings empty */
    } else {
	return(0);
    }
 }
 u_int8_t sch;				/* string character */
 u_int16_t tpos;			/* string position */
 tpos = 0;				/* start string position */
 sch = *(str + tpos);			/* read string character */
 while(tpos < count) {			/*string buffer position check */
    tpos += 1;				/* next string position */
    if(sch == '\0') {			/* string end character */
	return(0);			/* 0 */
    }
    if(rch != sch) {			/* characters test */
	return(0);			/* string not equal */
    }
    sch = *(str + tpos);		/* read string character */
    rch = *((u_int8_t *)buf + pos);	/* read character from buffer */
    pos += 1;				/* next buffer position */
    if(unsen > 0) {			/* case not sensitive check */
	if(sch >= 'A' && sch <= 'Z') {	/* source upper letter check */
	    sch = 'a' + (sch - 'A');	/* source character convert */
	}
	if(rch >= 'A' && rch <= 'Z') {	/* destination character upper case check */
	    rch = 'a' + (rch - 'A');	/* destination character convert */
	}
    }
    if(rch == '\0') {			/* buffer end test */
	if(tpos >= count) {		/* count check */
	    if(spos != 0) {		/* buffer position pointer check */
		*spos = pos;		/* position write */
	    }
	    return(1);
	} else {
	    return(0);			
	}
    }
 }
 if(spos != 0) {
    while(rch == ' ') {
	rch = *((u_int8_t *)buf + pos);	/* read character from buffer */
	pos += 1;
    }
    *spos = pos - 1;			/* position write */
 }
 return(1);				/* string found */
}
/* read string from buffer */
/* srd - string readed, output 1 - string readed */
int ustc_str(void * buf, u_int8_t * str, int len, int *spos, u_int8_t *cut, u_int8_t * srd)
{
 if(buf == 0) {				/* null buffer pointer */
    return(0);
 }
 u_int16_t pos;				/* buffer position */
 if(spos == 0) {
    pos = 0;				/* clear buffer position */
 } else {
    pos = *spos;			/* read buffer position */
 }
 u_int8_t rch;				/* readed character */
 rch = *((u_int8_t *)buf + pos);	/* read character from buffer */
 pos += 1;				/* next buffer position */
 while((rch == '\t') || (rch == ' ') || (rch == '\v')) {
    rch = *((u_int8_t *)buf + pos);	/* read next character */
    pos += 1;				/* next buffer position */
 }
 if(srd != 0) {				/* defined string readed */
    *srd = 0;				/* clear string readed flag */
 }
 u_int16_t dpos;			/* destination position */
 dpos = 0; 				/* start destination position */
 while(rch != '\0') {
    if(str != 0) {
	if(dpos < len) {
	    *(str + dpos) = rch;	/* write character to buffer */
	}
    }
    if(srd != 0) {			/* defined string readed */
	*srd = 1;			/* set string readed flag */
    }
    dpos += 1;				/* next destination position */
    rch = *((u_int8_t *)buf + pos);	/* read character from buffer */
    pos += 1;				/* next buffer position */
    if((rch == '\t') || (rch == ' ') || (rch == '\v')) {
	{ break; }
    }
 }
 if(len == 0) {
/* null destination length */
    if(cut != 0) {
        *cut = 1;			/* set cuting */
    }
 } else {
    if(dpos > len) {
    /* string cutted */
	if(cut != 0) {
	    *cut = 1;			/* write cuting */
	}
	dpos = len - 1;			/* end destination buffer position */
    } else {
    /* string not cutted */
	if(cut != 0) {
	    *cut = 0;
	}
    }
    if(str != 0) {			/* not null destination pointer */
        *(str + dpos) = '\0';		/* write null terminating character */
    }
 }
 if(spos != 0) {
    *spos = pos - 1;			/* not null position pointer -> write position*/
 }
 return(1);
}
/* read int from buffer */
/* ird - integer readed, output 1 - integer readed */
int ustc_int(void * buf, int * ival, int * ipos, u_int8_t *ird)
{
 if(buf == 0) {				/* null source buffer pointer */
    return(0);
 }
 u_int16_t pos;				/* source position */
 if(ipos == 0) {			
    pos = 0;				/* clear position */
 } else {
    pos = *ipos;			/* read source position */
 }
 u_int8_t rch;				/* readed character */
 rch = *((u_int8_t *)buf + pos);	/* read character */
 pos += 1;				/* next buffer position */ 
 while((rch == '\t') || (rch == ' ') || (rch == '\v')) {
    rch = *((u_int8_t *)buf + pos);	/* read character */
    pos += 1;				/* next buffer position */
 }
 int sign;				/* sign */
 if(rch == '-') {
    sign = -1;				/* negative */
    rch = *((u_int8_t *)buf + pos);	/* read character */
    pos += 1;				/* next buffer position */
    while((rch == '\t') || (rch == ' ') || (rch == '\v')) {
	pos += 1;
    }
 } else {
    sign = 1;				/* positive */
 }
 if(ird != 0) {				/* defined readed pointer */
    *ird = 0;				/* clear readed */
 }
 int val;				/* decimal value */
 val = 0;				/* start decimal value */
 while(rch != '\0') {
    if(rch >= '0' && rch <= '9') {
	val = (val * 10) + (rch - '0');
	if(ird != 0) {			/* defined readed pointer */
	    *ird = 1;			/* set readed pointer */
	}
    } else {
	{ break; }
    }
    rch = *((u_int8_t *)buf + pos);	/* read character */
    pos += 1;				/* next buffer position */
    if((rch == '\t') || (rch == ' ') || (rch == '\v')) {
	{ break; }
    }
 }
 if(ival != 0) {
    *ival = val * sign;			/* write integer value */
 }
 if(ipos != 0) {
    *ipos = pos - 1;			/* write buffer position */
 }
 return(1);
}
/* read hex integer from string */
int ustc_xint(void * buf, u_int32_t * uval, int * upos, u_int8_t *urd)
{
 if(buf == 0) {				/* null source buffer pointer */
    return(0);
 }
 u_int16_t pos;				/* source position */
 if(upos == 0) {			
    pos = 0;				/* clear position */
 } else {
    pos = *upos;			/* read source position */
 }
 u_int8_t rch;				/* readed character */
 rch = *((u_int8_t *)buf + pos);	/* read character */
 pos += 1;				/* next buffer position */ 
 while((rch == '\t') || (rch == ' ') || (rch == '\v')) {
    rch = *((u_int8_t *)buf + pos);	/* read character */
    pos += 1;				/* next buffer position */
 }
 if(urd != 0) {				/* defined readed pointer */
    *urd = 0;				/* clear readed */
 }
 int val;				/* decimal value */
 val = 0;				/* start decimal value */
 while(rch != '\0') {
    if(rch >= '0' && rch <= '9') {
	val = (val * 16) + (rch - '0');
	if(urd != 0) {			/* defined readed pointer */
	    *urd = 1;			/* set readed */
	}
    } else
    if(rch >= 'A' && rch <= 'F') {
	val = (val * 16) + 10 + (rch - 'A');
	if(urd != 0) {			/* defined readed pointer */
	    *urd = 1;			/* set readed pointer */
	}
    } else
    if(rch >= 'a' && rch <= 'f') {
	val = (val * 16) + 10 + (rch - 'a');
	if(urd != 0) {			/* defined readed pointer */
	    *urd = 1;			/* set readed */
	}
    } else {
	{ break; }
    }
    rch = *((u_int8_t *)buf + pos);	/* read character */
    pos += 1;				/* next buffer position */
    if((rch == '\t') || (rch == ' ') || (rch == '\v')) {
	{ break; }
    }
 }
 if(uval != 0) {
    *uval = val;			/* write integer value */
 }
 if(upos != 0) {
    *upos = pos - 1;			/* write buffer position */
 }
 return(1);
}
/* read double value */
int ustc_double(void * buf, double * dval, int * dpos, u_int8_t *drd)
{
 if(buf == 0) {				/* null buffer pointer */
    return(0);
 }
 u_int16_t pos;				/* buffer position */
 if(dpos == 0) {
    pos = 0;				/* clear buffer position */
 } else {
    pos = *dpos;			/* read buffer position */
 }
 u_int8_t rch;				/* readed character */
 rch = *((u_int8_t *)buf + pos);	/* read character */
 pos += 1;				/* next buffer position */
 while((rch == '\t') || (rch == ' ') || (rch == '\v')) {
    rch = *((u_int8_t *)buf + pos);	/* read character */
    pos += 1;				/* next buffer position */
 }
 if(drd != 0) {
    *drd = 0;
 }
 int sign;				/* sign */
 if(rch == '-') {
    if(drd != 0) {			/* defined double readed pointer */
	*drd = 1;			/* double readed */
    }
    sign = -1;				/* negative */
    rch = *((u_int8_t *)buf + pos);	/* read character */
    pos += 1;				/* next buffer position */
    while((rch == '\t') || (rch == ' ') || (rch == '\v')) {
	rch = *((u_int8_t *)buf + pos);	/* read character */
	pos += 1;			/* next buffer position */
    }
 } else {
    sign = 1;				/* positive */
 }
 double val;				/* value */
 val = 0;				/* start value */
 while((rch != '\0') && (rch != '.') && (rch != ' ') && (rch != '\t')) {
    if(rch >= '0' && rch <= '9') {
	val = val * 10 + (rch - '0');
	if(drd != 0) {			/* defined double readed pointer */
	    if(*drd == 0) {		/* double readed not set */
		*drd = 1;		/* double readed set*/
	    }
	}
    } else {
	{ break; }
    }
    rch = *((u_int8_t *)buf + pos);	/* read next character */
    pos += 1;				/* next buffer position */
 }
 if(rch == '.') {
    rch = *((u_int8_t *)buf + pos);	/* read next character */
    pos += 1;				/* next buffer position */
    double frac;			/* fractional part */
    frac = 1;				/* start part */
    while((rch != '\0') && (rch != ' ') && (rch != '\t')) {
	if(rch >= '0' && rch <= '9') {
	    frac = frac / 10;		/* calc fractional part */
	    val = val + (rch - '0') * frac; /* calculate double */
	    if(drd != 0) {		/* defined double readed pointer */
		if(*drd == 0) {		/* double readed not set */
		    *drd = 1;		/* double readed set*/
		}
	    }
	} else {
	    break;
	}
	rch = *((u_int8_t *)buf + pos); /* read character */
	pos += 1;			/* next buffer position */
    }
 }
 if(dval != 0) {
    *dval = val * sign;			/* write decimal value */
 }
 if(dpos != 0) {
    *dpos = pos - 1;			/* write destination position */
 }
 return(1);
}
int ustc_space(void * buf)	 	/* check space in null terminating string */
{
 if(buf == 0) {				/* buffer check */
    return(0);				/* space not found */
 }
 u_int8_t * bptr;			/* buffer pointer */
 bptr = (u_int8_t *)buf;		/* buffer pointer set */
 while(*bptr != '\0') {			/* buffer looop */
    if(
	(*bptr == ' ') || 		/* space check */
	(*bptr == '\t') || 		/* horizontal tab check */
	(*bptr == '\v')			/* vertical tab check */
    ) {
	return(1);
    }
    bptr += 1;				/* character next */
 }
 return(0);
}
int ustc_layer_clear(USTC_LAYER * uli)	/* clear layer information */
{
 if(uli == 0) {				/* null layer pointer */
    return(0);
 }
 uli->name = 0;				/* clear layer name */
 uli->num = 0;				/* clear layer number */
 return(1);
}
/* print layers */
int ustc_layers_print(void)
{
 if(ustc_layer == 0) {
    return(0);
 }
 u_int32_t lnum;
 for(lnum = 0; lnum < ustc_layer_count; ++lnum) {
    USTC_LAYER * uli;			/* layer pointer */
    uli = ustc_layer + lnum;		/* set layer pointer */
    if(uli->name != 0) {
	ustc_printf(
	    "%d. %s %d\r\n", 
	     lnum,			/* layer number */
	     uli->name, 		/* layer name */
	     uli->num			/* layer num */
	);
    }
 }
 return(1);
}
/* layer allocate */
int ustc_layer_alloc(u_int32_t count)
{
 if(count <= ustc_layer_count) {
    count = ustc_layer_count + count;
 }
 USTC_LAYER * slayer;			/* saved pointer */
 slayer = ustc_layer;			/* save layer pointer */
 ustc_layer = (USTC_LAYER *) malloc(sizeof(USTC_LAYER) * count);
 if(ustc_layer == 0) {
    ustc_layer = slayer;		/* layer buffer pointer restore */
    ustc_error("Layer buffer allocation error\r\n");
    return(0);
 }
 int rvl;				/* return code */
 rvl = 1;				/* clear return code */
 if(slayer != 0) {
    u_int32_t lnum;
    for(lnum = 0; lnum < ustc_layer_count; ++lnum) {
	USTC_LAYER * dli;		/* destination layer */
	USTC_LAYER * sli;		/* source layer */
	dli = ustc_layer + lnum;	/* set destination layer */
	sli = slayer + lnum;		/* set source layer */ 
	*dli = *sli;
    }
    for(; lnum < ustc_layer_count; ++lnum) {
	USTC_LAYER * uli;		/* layer pointer */
	uli = ustc_layer + lnum;	/* set layer pointer */
	if(ustc_layer_clear(uli) == 0) {
	    rvl = 0;
	}
    }
 }
 if(slayer != 0) {
    free(slayer);
    slayer = 0;
 }
 ustc_layer_count = count;
 return(rvl);
}
/* layer add */
/* return (0), failure, layer number */
int ustc_layer_add(u_int32_t *lnum, u_int8_t * nam, int tnum)
{
 if(nam == 0) {				/* null layer number pointer */
    return(0);
 }
 u_int32_t num;				/* layer number */
 if(lnum == 0) {			/* null layer number */
    for(num = 0; num < ustc_layer_count; ++num) {
	USTC_LAYER * uli;		/* layer pointer */
	uli = ustc_layer + num;		/* set layer pointer */
	if(uli->name == 0) {		/* null name pointer */
	    { break; }			/* -> number allocated */
	}
    }
 } else {
    num = *lnum;			/* read layer number */
 }
 if(num >= ustc_layer_count) {
/* allocate layer */
    int rvl; 				/* return code */
    rvl = 1;				/* start return code */
    if(ustc_layer_alloc(100) == 0) {
	rvl = 0;			/* allocation error */
    }
    if(rvl == 1) {
/* check allocation error */
	if(num >= ustc_layer_count) {
	    rvl = 0;			/* allocation error */
	}
    }
    if(rvl == 0) {
    	ustc_error("Error layer allocate\r\n");
	return(0);
    }
 }
 USTC_LAYER * dli;			/* destination cad layer */
 dli = ustc_layer + num;		/* set destination cad layer pointer */
 int len;
 len = strlen((char *)nam) + 1;		/* calculate buffer length */
 dli->name = (u_int8_t *) malloc(len);
 if(dli->name == 0) {
    ustc_error("Memory alloc error\r\n");
    return(0);
 }
 snprintf(
    (char *)dli->name,			/* layer name buffer */
    len,				/* layer name length */
    "%s",				/* format */
    (char *)nam				/* name */
 ); 
 dli->num = tnum;			/* write layer translate number */
 if(lnum != 0) {
    *lnum += 1;				/* next layer number */
 }
 return(num);
}
/* free layer */
int ustc_layer_free(void)
{
 if(ustc_layer != 0) {
    u_int32_t lnum;
    for(lnum = 0; lnum < ustc_layer_count; ++lnum) {
	USTC_LAYER * uli;
	uli = ustc_layer + lnum;
	if(uli->name != 0) {
	    free(uli->name);
	    uli->name = 0;
	}
    }
    free(ustc_layer);
    ustc_layer = 0;
 }
 ustc_layer_count = 0;
 return(1);
}
/* layer find */
int ustc_layer_num(u_int8_t * name)
{
 if(
    (name == 0) ||			/* null name layer pointer */
    (ustc_layer == 0)			/* null layer table */
 ) {
    return(-1);
 }
 u_int32_t lnum;			/* layer number */
 for(lnum = 0; lnum < ustc_layer_count; ++lnum) {
    USTC_LAYER * uli;			/* layer pointer */
    uli = ustc_layer + lnum;		/* set layer pointer */
    if(uli->name != 0) {
	if(strcmp((char *)uli->name,(char *)name) == 0) {
	    return(lnum);
	}
    }
 }
 return(-1);
}
