#include <stdio.h>			/* */
#include <stdarg.h>			/* */
#include <string.h>			/* */
#include <malloc.h>			/* */
#include <stdlib.h>			/* */
#include <unistd.h>			/* */
#include <time.h>			/* */

#include <errno.h>			/* */
#include <ctype.h>			/* */
#include <fcntl.h>			/* */
#include <pwd.h>			/* */	
#include <setjmp.h>			/* */		
#include <signal.h>			/* */
#include <stdio.h>			/* */
#include <stdlib.h>			/* */
#include <string.h>			/* */
#include <syslog.h>			/* */
#include <termios.h>			/* */
#include <unistd.h>			/* */

#include <sys/errno.h>			/* */
#include <sys/file.h>			/* */
#include <sys/ioctl.h>			/* */
#include <sys/param.h>			/* */
#include <sys/resource.h>		/* */
#include <sys/stat.h>			/* */
#include <sys/time.h>			/* */
#include <sys/types.h>			/* */
#include <sys/utsname.h>		/* */	
#include <sys/wait.h>			/* */
#include <math.h>			/* */
#include "ustcio.hpp"
#include "ustclib.hpp"
#define USTCLIB_LICENSE \
"USTCLIB 0.1 (c) 2006-2010 Dmitriy I.Cherkashin, www.ucrouter.ru\r\n"  \
"email: dch@ucrouter.ru , divch@users.sourceforge.net , dch@ucrouter.com\r\n"  \
"phone: +8-909-936-8809; ICQ: 474-363-900;\r\n"  \
"This library is free software with source codes\r\n"  \
"downloadable via internation communicational net.\r\n"  \
"If you have source codes of this software original or modified,\r\n"  \
"you must provide ability to free receive original source codes\r\n"  \
"of this software to another users even in internation communicational\r\n"  \
"net absense without any unusual additional payment exept\r\n" \
"downloading files from internation communicational net cost or\r\n" \
"mail cost.\r\n"
#define USTCLIB_LICENSE_RU \
"USTCLIB 0.1 (c) 2006-2010  ., www.ucrouter.ru\r\n" \
" : dch@ucrouter.ru,divch@users.sourceforge.net,dch@ucrouter.com\r\n"  \
": +8-909-936-8809; ICQ: 474-363-900;\r\n" \
"     \r\n" \
"      \r\n" \
" .\r\n" \
"       \r\n" \
"  ,     \r\n" \
"     \r\n" \
"     \r\n" \
"      \r\n" \
"       \r\n" \
"    \r\n" \
"     .\r\n"
u_int8_t * ustclib_license    = (u_int8_t *)USTCLIB_LICENSE;
u_int8_t * ustclib_license_ru = (u_int8_t *)USTCLIB_LICENSE_RU;
int ustc_lib_header_clear(USTC_LIB_HEADER * uli) /* lib header clear */
{
 if(uli == 0) {				/* null lib header check */
    return(0);
 }
 uli->header = 0;			/* header pointer set */
 uli->versionhi = (u_int8_t)(-1);	/* version hi */
 uli->versionlo = (u_int8_t)(-1);	/* version lo */
 uli->day = (u_int8_t)(-1);		/* month day */
 uli->mon = (u_int8_t)(-1);		/* month */
 uli->year = (u_int32_t)(-1);		/* year */
 uli->hour = (u_int8_t)(-1);		/* hour */
 uli->min = (u_int8_t)(-1);		/* minute */
 uli->sec = (u_int8_t)(-1);		/* second */
 return(1);
}
int ustc_lib_alias_clear(USTC_LIB_ALIAS * ulai)	/* lib alias clear */
{
 if(ulai == 0) {			/* lib alias pointer check */
    return(0);
 }
 ulai->name = (u_int8_t *)(0);		/* lib alias clear */
 return(1);
}
int ustc_lib_field_clear(USTC_LIB_FIELD * ulfi)	/* lib field clear */
{
 if(ulfi == 0) {			/* lib field pointer check */
    return(0);
 }
 ulfi->name = 0;			/* text name */
 ulfi->x0 = 0;				/* x position, mills */
 ulfi->y0 = 0;				/* y position, mills */
 ulfi->height = 0;			/* text height */
 ulfi->ornt = USTC_LIB_FIELD_ORNT_UNKNOWN; /* field orientation */
 ulfi->vis = 0;				/* field visible */
 ulfi->hor = USTC_LIB_FIELD_HOR_UNKNOWN; /* horizontal justify */
 ulfi->vert = USTC_LIB_FIELD_VERT_UNKNOWN; /* vertical justify unknown */	
 return(1);
}
int ustc_lib_poly_clear(USTC_LIB_POLY * ulpi)	/* lib poly clear */
{
 if(ulpi == 0) {			/* lib poly pointer check */
    return(0);
 }
 ulpi->x0 = 0;				/* x position, mills */
 ulpi->y0 = 0;				/* y position, mills */
 return(1);
}
int ustc_lib_rect_clear(USTC_LIB_RECT * ulri)	/* lib rect clear */
{
 if(ulri == 0) {			/* lib rect pointer check */
    return(0);				/* null pointer -> return */
 }
 ulri->x0 = 0;				/* x0 position, mills */
 ulri->y0 = 0;				/* y0 position, mills */
 ulri->x1 = 0;				/* x1 position, mills */
 ulri->y0 = 0;				/* y1 position, mills */
 ulri->fill = 0;			/* rect filling */
 return(1);
}
int ustc_lib_ring_clear(USTC_LIB_RING * ulri)	/* lib ring clear */
{
 if(ulri == 0) {			/* lib ring pointer check */
    return(0);
 }
 ulri->x0 = 0;				/* x0 position, mills */
 ulri->y0 = 0;				/* y0 position, mills */
 ulri->rad = 0;
 ulri->fill = USTC_LIB_RING_FILL_UNKNOWN;
 return(1);
}
int ustc_lib_arc_clear(USTC_LIB_ARC * ulai) /* kicad lib arc clear */	
{
 if(ulai == 0) {			/* lib arc pointer check */
    return(0);				/* null pointer -> function return */
 }
 ulai->x0 = 0;				/* x0 point */
 ulai->y0 = 0;				/* y0 point */
 ulai->rad = 0;				/* radius */
 ulai->start = 0;			/* start angle */
 ulai->end = 0;				/* end angle */
 ulai->xs = 0;				/* x start */
 ulai->ys = 0;				/* y start */
 ulai->xe = 0;				/* x end */
 ulai->ye = 0;				/* y end */
 ulai->fill = USTC_LIB_ARC_FILL_UNKNOWN; /* fillingclear */
 return(1);
}
int ustc_lib_text_clear(USTC_LIB_TEXT * ulti) /* kicad lib text clear */
{
 if(ulti == 0) {			/* kicad lib text pointer check */
    return(0);
 }
 ulti->ornt = USTC_LIB_TEXT_ORNT_UNKNOWN; /* orientation */
 ulti->x0 = 0;				/* x point */
 ulti->y0 = 0;				/* y point */
 ulti->height = 0;			/* text height */
 ulti->unused = 255;
 ulti->text = 0;			/* text */
 return(1);
}
int ustc_lib_draw_clear(USTC_LIB_DRAW * uldi)	/* lib draw clear */
{
 if(uldi == 0) {			/* lib draw pointer check */
    return(0);
 }
 uldi->type = USTC_LIB_DRAW_UNKNOWN; 	/* draw segment type */
 uldi->unit = 0;			/* 0 - common in all parts, else part number */
 uldi->convert = 0;			/* 0 - common in 2 representations, else 1 or 2 */
 uldi->width = 0; 			/* line width */
 uldi->ref = 0; 			/* draw reference */
 return(1);
}
int ustc_lib_pin_clear(USTC_LIB_PIN * ulpi)	/* kicad lib pin clear */
{
 if(ulpi == 0) {			/* lib pin pointer check */
    return(0);
 }
 ulpi->name = 0;			/* pin name clear */
 ulpi->num = 0;				/* pin number clear */
 ulpi->x0 = 0;				/* x position */
 ulpi->y0 = 0;				/* y position */
 ulpi->length = 0;			/* pin length */
 ulpi->ornt = USTC_LIB_PIN_ORNT_UNKNOWN; /* pin orientation */
 ulpi->numheight = 0;			/* number height */
 ulpi->nameheight = 0;			/* name height */
 ulpi->unit = 0;			/* 0 common in all parts */
 ulpi->convert = 0;			/* 0 common in all representation */
 ulpi->etype = 0;			/* etype */
 ulpi->shape = 0;			/* shape */
 return(1);
}
int ustc_lib_comp_clear(USTC_LIB_COMP * ulci)	/* kicad lib comp clear */
{
 if(ulci == 0) {			/* lib comp pointer null check */
    return(0);				/* return error */
 }
 ulci->name = 0;			/* name */
 ulci->reference = 0;			/* reference */
 ulci->unused = 0;			/* unused */
 ulci->offset = 0;			/* offset */
 ulci->pinnumvis = 0;			/* pin number visible */
 ulci->pinnamvis = 0;			/* pin name visible */
 ulci->units = 0;			/* units */
 ulci->unitlock = 0;			/* unit lock or swap disable */
 ulci->power = 0;			/* power */
 ulci->alias = 0;			/* alias reference */
 ulci->alcount = 0;			/* alias count */
 ulci->ref = (u_int32_t)(-1);		/* field reference */
 ulci->val = (u_int32_t)(-1);		/* field value */
 ulci->pcb = (u_int32_t)(-1);		/* field pcb footprint */
 ulci->diagram = (u_int32_t)(-1);	/* field diagram */
 ulci->field = (u_int32_t)(-1);		/* field reference */
 ulci->fcount = 0;			/* field count */
 ulci->draw = 0;			/* draw reference */
 ulci->dcount = 0;			/* draw count */
 ulci->pin = 0;				/* pin reference */
 ulci->pcount = 0;			/* pin count */
 return(1);
}
int ustc_lib_header_print(USTC_LIB_HEADER * uli) /* lib header print */
{
 if(
    (uli == 0) ||			/* null lib pointer */
    (ustc_fo == 0)			/* null output file pointer */
 ) {
    return(0);
 }
 u_int8_t name[128];			/* header buffer */
 u_int32_t size = sizeof(name);		/* buffer size */
 int pos;				/* buffer position */
 pos = snprintf(
    (char *)name,		        /* header buffer */
    size,				/* buffer size */
    "EESchema-LIBRARY Version"
 );
 if(
    (uli->versionhi == (u_int8_t)(-1)) && /* version hi check */
    (uli->versionlo == (u_int8_t)(-1))	/* version lo check */
 ) {					/* write null version */
    pos += snprintf(			
	(char *) name + pos,		/* version number buffer */
	size - pos,			/* bytes remained */
	" 0"
    );
 } else {				/* not null version */
    if(uli->versionhi != (u_int8_t)(-1)) {
	pos += snprintf(
	    (char *) name + pos,	/* version number hi buffer */
	    size - pos,			/* bytes remained */
	    " %d",			/* format */
	    uli->versionhi		/* version hi */
	);
    }
    if(uli->versionlo != (u_int8_t)(-1)) {
	if(uli->versionhi == (u_int8_t)(-1)) {
	    pos += snprintf(		/*  not defined version hi -> write space */
		(char *) name + pos,
		size - pos,
		" "
	    );
	}
	pos += snprintf(		/* separator and version lo write */
	    (char *) name + pos,	/* separator and version lo buffer */
	    size - pos,			/* bytes in buffer */
	    ".%d",			/* format */
	    uli->versionlo		/* version lo */
	);
    }
 }
 pos += snprintf(			
    (char *) name + pos,		/* version number buffer */
    size - pos,				/* bytes remained */
    " Date:"
 );
 if(uli->day != (u_int8_t)(-1)) {	/* month day */
    pos += snprintf(			/* write day */
        (char *)name + pos,		/* header buffer */
        size - pos,			/* header buffer size */
        " %d",				/* format */
        uli->day			/* header day */
    );
 } else {
    pos += snprintf(			/* print default day */ 
	(char *)name + pos, 		/* header buffer */
	size - pos, 			/* header buffer bytes tail */
	" 11"
    );
 }
 if(uli->mon != (u_int8_t)(-1)) {	/* month */
    pos += snprintf(			/* month write */
        (char *)name + pos,	/* month buffer */
        size - pos,			/* mont buffer size */
        "/%d",				/* format */
        uli->mon			/* month */
    );
 } else {				/* print default month */    
    pos += snprintf(
	(char *)name + pos, 		/* header buffer */
	size - pos, 			/* header buffer bytes tail */
	"/1"				/* mont default */
    );
 }
 if(uli->year != (u_int16_t)(-1)) {	/* year */
    pos += snprintf(			/* year write */
        (char *)name + pos,		/* year bufer */
        size - pos,			/* year buffer size */
        "/%d",				/* format */
        uli->year			/* year */
    );
 } else {				/* print default year */
    pos += snprintf(
	(char *)name + pos, 		/* header buffer */
	size - pos, 			/* header buffer bytes tail */
	"/1965"				/* year default */
    );
 }
 if(uli->hour != (u_int8_t)(-1)) {	/* hour */
    pos += snprintf(			/* hour write */
        (char *)name + pos,		/* hour buffer */
        size - pos,			/* hour buffer size */ 
        "-%d",				/* format */
        uli->hour			/* hour */
    );
 } else {				/* print default hour */
    pos += snprintf(
	(char *)name + pos, 		/* header buffer */
	size - pos, 			/* header buffer bytes tail */
	"-9"				/* hour default */
    );
 }
 if(uli->min != (u_int8_t)(-1)) {	/* minute */
    pos += snprintf(			/* minute write */
        (char *)name + pos,		/* minute buffer */
        size - pos,			/* minute buffer size */
        ":%d",				/* format */
        uli->min			/* minute */
    );
 } else {				/* print default minute */
    pos += snprintf(
	(char *)name + pos, 		/* header buffer */
	size - pos, 			/* header buffer bytes tail */
	":35"				/* minutes default */
    );
 }
 if(uli->sec != (u_int8_t)(-1)) {	/* second */
    pos += snprintf(			/* second write */
        (char *)name + pos,		/* second write buffer */
        size - pos,			/* second buffer size */
        ":%d",				/* format */
        uli->sec			/* second */
    );
 } else {				/* default second */
    pos += snprintf(
	(char *)name + pos, 		/* header buffer */
	size - pos, 			/* header buffer bytes tail */
	":48"				/* second default */
    );
 }
 int len;				/* header length */
 len = strlen((char *) name) + 1;	/* header length calculate */
 uli->header = (u_int8_t *)malloc(len);	/* header buffer allocation */
 if(uli->header == 0) {			/* header buffer allocation check */
    ustc_error(
	"KICAD LIB header allocation error\r\n");
    return(0);
 } else {
    snprintf(
	(char *) uli->header,
	len,
	"%s",
	name
    );
 }
 if(ustc_fo != 0) {
    fprintf(ustc_fo, "%s", uli->header);
 }
 if(ustc_nl_print > 0) {
    fprintf(ustc_fo, "\r\n");
 } else {
    fprintf(ustc_fo, "\n");
 }
 return(1);
}
int ustc_lib_alias_print(USTC_LIB_ALIAS * ulai, u_int32_t count)
{
 if(
    (ulai == 0) ||			/* null lib pointer */
    (ustc_fo == 0)			/* null output file pointer */
 ) {
    return(0);
 }
 fprintf(ustc_fo, "ALIAS");		/* alias */
 while(count > 0) {			/* alias print loop */
    if(ulai->name != 0) {		/* alias name pointer check */
	fprintf(ustc_fo, " %s", ulai->name); /* alias print */	
    }
    count -= 1;				/* aliases remain */
    ulai += 1;				/* alias next pointer */
 }
 if(ustc_nl_print > 0) {
    fprintf(ustc_fo, "\r\n");
 } else {
    fprintf(ustc_fo, "\n");
 }
 return(1);
}
int ustc_lib_field_print(u_int32_t fnum, USTC_LIB_FIELD * ulfi)
{
 if(
    (ulfi == 0) ||			/* null lib pointer */
    (ustc_fo == 0)			/* null output file pointer */
 ) {
    return(0);
 }
 fprintf(ustc_fo, "F%d", fnum);		/* field number print */
 u_int8_t * rstr;			/* orientation string */
 if(ulfi->ornt == USTC_LIB_FIELD_ORNT_HOR) { /* orientation horizontal */
    rstr = (u_int8_t *)"H";		/* orientation horizontal string */
 } else
 if(ulfi->ornt == USTC_LIB_FIELD_ORNT_VERT) { /* orientation vertical */
    rstr = (u_int8_t *)"V";		/* orientation vertical string */
 } else {
    rstr = (u_int8_t *)"H";		/* orientation default string */
 }
 u_int8_t * vsstr;			/* visibility string */
 if(ulfi->vis > 0) {			/* field visibility check */
    vsstr = (u_int8_t *)"V";		/* field visible */
 } else {
    vsstr = (u_int8_t *)"I";		/* field invisible */
 }
 u_int8_t * hstr;			/* horizontal justification string*/
 if(ulfi->hor == USTC_LIB_FIELD_HOR_L) { /* horizontal justificaton left check*/
    hstr = (u_int8_t *)"L";		/* horizontal left string */
 } else
 if(ulfi->hor == USTC_LIB_FIELD_HOR_C) { /* horizontal justificaton center check*/
    hstr = (u_int8_t *)"C";		/* horizontal center string */
 } else
 if(ulfi->hor == USTC_LIB_FIELD_HOR_R) { /* horizontal justificaton right check*/
    hstr = (u_int8_t *)"R";		/* horizontal right string */
 } else {
    hstr = (u_int8_t *)"L";		/* horizontal default string */
 }
 u_int8_t * vstr;			/* vertical justification string */
 if(ulfi->vert == USTC_LIB_FIELD_VERT_B) { /* vertical bottom justification check */
    vstr = (u_int8_t *)"B";	
 } else
 if(ulfi->vert == USTC_LIB_FIELD_VERT_C) { /* vertical justification center check */
    vstr = (u_int8_t *)"C";		/* vertical justification text string */
 } else
 if(ulfi->vert == USTC_LIB_FIELD_VERT_T) {  /* vertical justification top check */
    vstr = (u_int8_t *)"T";		/* vertical justification top string */
 } else {
    vstr = (u_int8_t *)"B";		/* vertical justification default string */
 }
 fprintf(
    ustc_fo, 				/* output file descriptor */
    " \"%s\" %d %d %d %s %s %s %s",		/* format */
    ulfi->name,				/* field name */
    ulfi->x0,				/* field x position */
    ulfi->y0,				/* field y position */
    ulfi->height,			/* text height */
    rstr,				/* orientation string */
    vsstr,				/* visibility string */
    hstr,				/* horizontal justification string */
    vstr				/* vertical justification string */
 );
 if(ustc_nl_print > 0) {
    fprintf(ustc_fo, "\r\n");
 } else {
    fprintf(ustc_fo, "\n");
 }
 return(1);
}
int ustc_lib_poly_print(USTC_LIB_POLY * ulpi, u_int32_t count)
{
 if(
    (ulpi == 0) ||			/* null lib pointer */
    (ustc_fo == 0)			/* null output file pointer */
 ) {
    return(0);
 }
 while(count > 0) {
    fprintf(
	ustc_fo, 			/* output file descriptor */
	" %d %d",			/* format */
	ulpi->x0,			/* poly x position */
        ulpi->y0			/* poly y position */
    );
    count -= 1;				/* points remain */
    ulpi += 1;				/* point next pointer  */
 }
 return(1);
}
int ustc_lib_draw_print(USTC_LIB_DRAW * uldi)
{
 if(
    (uldi == 0) ||			/* null lib pointer */
    (ustc_fo == 0)			/* null output file pointer */
 ) {
    return(0);
 }
 if(uldi->type == USTC_LIB_DRAW_POLY) {	/* poly type check */ 
     if(uldi->ref >= ustc_lib_poly_count) { /* out of poly buffer  check */
	ustc_error("Out of KICAD LIB poly buffer, reference {%d}, poly buffer item count {%d}\r\n",
	    uldi->ref,			/* poly reference reference number */
	    ustc_lib_poly_count		/* kicad lib poly buffer size */
	);
	return(0);
    }
    USTC_LIB_POLY * ulpi;		/* kicad lib poly pointer */
    ulpi = ustc_lib_poly + uldi->ref;	/* kicad lib poly pointer set */
    int32_t count;			/* points count */
    u_int8_t fill;			/* poly fillinng */
    count = ulpi->x0;			/* points count read */
    fill = ulpi->y0;			/* filling read */
    ulpi += 1;				/* next point pointer */
    u_int32_t num;			/* point number */
    num = uldi->ref + 1;		/* point number calculate */
    if(count > 0) {
	if(num + (count - 1) >= ustc_lib_poly_count) {
	    ustc_error("Out of KICAD LIB poly buffer, end point reference {%d}, item count {%d}\r\n",
		num + (count - 1),	/* end point item number */
		ustc_lib_poly_count	/* kicad lib point buffer count */
	    );
	    return(0);
	}
	fprintf(			/* poly header form */
	    ustc_fo,			/* output file descriptor */
	    "P %d %d %d %d",		/* format */
	    count,			/* item count */
	    uldi->unit,			/* 0 - common in all parts, else part number */
	    uldi->convert,		/* 0 - common in 2 representations, else 1 or 2 */
	    uldi->width 		/* line width */
	);
	int rvl;			/* return code */
	rvl = 1;			/* start return code */
	if(ustc_lib_poly_print(		/* points print */
	    ulpi, 			/* point start pointer */
	    count			/* point count */
	) == 0) {
	    rvl = 0;			/* return code clear */
	}
	if(fill == USTC_LIB_POLY_FILL_DC) {
	    fprintf(ustc_fo, " DC");
	} else
	if(fill == USTC_LIB_POLY_FILL_FILL) {
	    fprintf(ustc_fo, " F");
	} else
	if(fill == USTC_LIB_POLY_FILL_YES) {
	    fprintf(ustc_fo, " Y");
	} else
	if(fill == USTC_LIB_POLY_FILL_NO) {
	    fprintf(ustc_fo, " N");
	}
	if(ustc_nl_print > 0) {
	    fprintf(ustc_fo, "\r\n");
	} else {
	    fprintf(ustc_fo, "\n");
	}
	return(rvl);
    }
 } else
 if(uldi->type == USTC_LIB_DRAW_RECT) {	/* rectangle type check */
    if(uldi->ref >= ustc_lib_rect_count) {
	ustc_error("Out of KICAD LIB rectangle buffer, reference {%d}\r\n",
	    uldi->ref
	);
	return(0);
    }
    USTC_LIB_RECT * ulri;		/* rectangle pointer */
    ulri = ustc_lib_rect + uldi->ref;	/* rectangle pointer set */
    u_int8_t fstr[2];
    fstr[1] = '\0';
    if(ulri->fill == 1) {
	fstr[0] = (u_int8_t)'F';	/* rect filling */
    } else
    if(ulri->fill == 0) {
	fstr[0] = (u_int8_t)'N';	/* rect filling */
    } else {
	fstr[0] = ulri->fill;		/* rect filling */
    }
    fprintf(				/* print rectangle */
	ustc_fo,			/* output file name descriptor */
	"S %d %d %d %d %d %d %d %s",	/* format */
	ulri->x0,			/* x0 position */
	ulri->y0,			/* y0 position */
	ulri->x1,			/* x1 position */
	ulri->y1,			/* yi position */
	uldi->unit,			/* 0 - common in all parts, else part number */
	uldi->convert,			/* 0 - common in 2 representations, else 1 or 2 */
	uldi->width, 			/* line width */
	fstr				/* filling string */
    );
    if(ustc_nl_print > 0) {
        fprintf(ustc_fo, "\r\n");
    } else {
        fprintf(ustc_fo, "\n");
    }
 } else
 if(uldi->type == USTC_LIB_DRAW_ARC) {	/* arc */
    if(uldi->ref >= ustc_lib_arc_count) { /* arc reference check */	
	ustc_error("Out of KICAD LIB arc buffer, reference {%d}\r\n",
	    uldi->ref			/* arc reference */
	);
	return(0);
    }
    USTC_LIB_ARC * ulai;		/* kicad lib arc pointer */
    ulai = ustc_lib_arc + uldi->ref;	/* kicad lib arc pointer set */
    u_int8_t * fntstr;			/* fill not string */
    u_int8_t * fddstr;			/* fill yes string */
    u_int8_t * fstr;			/* fill string */
    fstr = (u_int8_t *)"";		/* fill string */
    fntstr = (u_int8_t *)" N";		/* fill not string*/
    fddstr = (u_int8_t *)" Y";		/* filee yes string */
    if(ulai->fill == USTC_LIB_ARC_FILL_UNKNOWN) {
	fprintf(			/* print arc */
	    ustc_fo,			/* output arc descriptor */
	    "To "
	);
    } else {
	fprintf(			/* print arc extended header */
	    ustc_fo,			/* output arc descriptor */
	    "A "
	);
	if(ulai->fill == USTC_LIB_ARC_FILL_FILL) {
	    fstr = fddstr;
	} else
	if(ulai->fill == USTC_LIB_ARC_FILL_NO) {	
	    fstr = fntstr;
	}
    }
    fprintf(				/* print arc */
	ustc_fo,			/* output arc descriptor */
	"%d %d %d %d %d "
	"%d %d %d%s "
	"%d %d %d %d",
	ulai->x0,			/* x center */
	ulai->y0,			/* y center */
	ulai->rad,			/* radius */
	ulai->start,			/* start angle. 0.1 degree */
	ulai->end,			/* end angle. 0.1 degree */
	uldi->unit,			/* 0 - common in all parts, else part number */
	uldi->convert,			/* 0 - common in 2 representations, else 1 or 2 */
	uldi->width, 			/* line width */
	fstr,
	ulai->xs,			/* x start */
	ulai->ys,			/* y start */
	ulai->xe,			/* x end */
	ulai->ye			/* y end */
    );
    if(ustc_nl_print > 0) {
        fprintf(ustc_fo, "\r\n");
    } else {
        fprintf(ustc_fo, "\n");
    }
 } else
 if(uldi->type == USTC_LIB_DRAW_RING) {	/* circ */
    if(uldi->ref >= ustc_lib_ring_count) { /* circ reference check */
	ustc_error("Out of KICAD LIB ring buffer, reference {%d}\r\n",
	    uldi->ref			/* circ reference number */
	);
	return(0);
    }
    USTC_LIB_RING * ulri;		/* kicad lib circ */
    ulri = ustc_lib_ring + uldi->ref;	/* kicad lib circ set pointer */
    if(ulri->fill == USTC_LIB_RING_FILL_UNKNOWN) {
	fprintf(
	    ustc_fo,			/* output file description pointer */
	    "R "			/* format */
	);
    } else {
	fprintf(
	    ustc_fo,			/* output file description pointer */
	    "C "			/* format */
	);
    }
    fprintf(
	ustc_fo,			/* output file description pointer */
	"%d %d %d %d %d %d",		/* format */
	ulri->x0,			/* x center */
	ulri->y0,			/* y center */
	ulri->rad,			/* radius */
	uldi->unit,			/* 0 - common in all parts, else part number */
	uldi->convert,			/* 0 - common in 2 representations, else 1 or 2 */
	uldi->width 			/* line width */
    );
    if(ulri->fill == USTC_LIB_RING_FILL_NO) {
	fprintf(ustc_fo," N");
    } else
    if(ulri->fill == USTC_LIB_RING_FILL_FILL) {
	fprintf(ustc_fo," F");
    } else
    if(ulri->fill == USTC_LIB_RING_FILL_YES) {
	fprintf(ustc_fo," Y");
    }
    if(ustc_nl_print > 0) {
        fprintf(ustc_fo, "\r\n");
    } else {
        fprintf(ustc_fo, "\n");
    }
 } else
 if(uldi->type == USTC_LIB_DRAW_TEXT) {	/* text */
    if(uldi->ref >= ustc_lib_text_count) {
	ustc_error("Out of KICAD LIB text buffer, reference {%d}\r\n",
	    uldi->ref
	);
	return(0);
    }
    USTC_LIB_TEXT * ulti;		/* kicad lib text */
    ulti = ustc_lib_text + uldi->ref;	/* kicad lib text set pointer */
    u_int8_t * rstr;
    if(ulti->ornt == USTC_LIB_TEXT_ORNT_HOR) { 	/* orientation horizontal */
	rstr = (u_int8_t *)"0";
    } else
    if(ulti->ornt == USTC_LIB_TEXT_ORNT_VERT) { /* orientation vertical */
	rstr = (u_int8_t *)"1";
    } else {
	rstr = (u_int8_t *)"0";
    }
    u_int8_t npstr[5];			/* unused buffer */
    if(ulti->unused == 255) {		/* text unused check */
	npstr[0] = 0;			/* unused clear */
    } else {
	snprintf(			/* unused string form */
	    (char *)npstr,		/* unused buffer */
	    sizeof(npstr),		/* unused buffer size */
	    "%d ",			/* format */
	    ulti->unused		/* unused field */
	);
    }
    fprintf(				/* text information print */
	ustc_fo,			/* output file description pointer */
	"T %s %d %d %d %d %d %s%s",	/* format */
	rstr,				/* orientation string */
	ulti->x0,			/* x position */
	ulti->y0,			/* y position */
	ulti->height,			/* text height */
	uldi->unit,			/* 0 - common in all parts, else part number */
	uldi->convert,			/* 0 - common in 2 representations, else 1 or 2 */
	npstr,
	ulti->text			/* text string */
    );
    if(ustc_nl_print > 0) {
        fprintf(ustc_fo, "\r\n");
    } else {
        fprintf(ustc_fo, "\n");
    }
 } else {
    ustc_error(				/* print error message */
	"Unknown KICAD LIB draw element type {%d}\r\n", 
	uldi->type
    );
    return(0);
 }
 return(1);
}
int ustc_lib_pin_print(USTC_LIB_PIN * ulpi) /* kicad lib print */
{
 if(
    (ulpi == 0) ||			/* null lib pointer */
    (ustc_fo == 0)			/* null output file pointer */
 ) {
    return(0);
 }
 if(ulpi->name == 0) {			/* cad pin name null pointer check */
    return(0);
 }
 u_int8_t * rntstr;			/* orientation string */
 if(ulpi->ornt == USTC_LIB_PIN_ORNT_UP) { /* orientation up check */
    rntstr = (u_int8_t *)"U";		/* orientation up string */
 } else
 if(ulpi->ornt == USTC_LIB_PIN_ORNT_DOWN) { /* orientation down check */
    rntstr = (u_int8_t *)"D";		/* orientation down string */
 } else
 if(ulpi->ornt == USTC_LIB_PIN_ORNT_RIGHT) { /* orientation right check */
    rntstr = (u_int8_t *)"R";		/* orientation right string */
 } else
 if(ulpi->ornt == USTC_LIB_PIN_ORNT_LEFT) { /* orientation left check */
    rntstr = (u_int8_t *)"L";		/* orientation left string */
 } else {
    rntstr = (u_int8_t *)"L";		/* default orientation */
 }
 u_int8_t tbuf[2];			/* type buffer */
 tbuf[0] = ulpi->etype;			/* 11, etype character */
 tbuf[1] = '\0';			/* type string terminator */
 u_int8_t sbuf[3];			/* shape buffer */
 sbuf[1] = '\0';			/* shape string terminator */
 sbuf[2] = '\0';			/* shape string terminator */
 sbuf[0] = ulpi->shape;			/* 12, shape character */
 sbuf[1] = (ulpi->shape >> 8);		/* 12, shape character */
 u_int8_t spbuf[2];			/* separator buffer */
 if(ulpi->shape != 0) {
    spbuf[0] = ' ';			/* separator character */
 } else {
    spbuf[0] = '\0';			/* enpty separator */
 }
 spbuf[1] = '\0';
 fprintf(				/* print pin information */
    ustc_fo,				/* output file structure pointer */
    "X %s %d %d %d %d "
    "%s %d %d %d %d "
    "%s%s%s",				/* format */
    ulpi->name,				/* 1 pin name */
    ulpi->num,				/* 2 pin number */
    ulpi->x0,				/* 3 x position */
    ulpi->y0,				/* 4 y position */
    ulpi->length,			/* 5 pin length */
    rntstr,				/* 6 pin orientation */
    ulpi->numheight,			/* 7 number height */
    ulpi->nameheight,			/* 8 name height */
    ulpi->unit,				/* 9, 0 common in all parts */
    ulpi->convert,			/* 10, 0 common in all representation */
    tbuf,				/* 11, type string */
    spbuf,				/* separator buffer */
    sbuf				/* 12, shape string */
 );
 if(ustc_nl_print > 0) {
    fprintf(ustc_fo, "\r\n");
 } else {
    fprintf(ustc_fo, "\n");
 }
 return(1);
}
int ustc_lib_comp_print(USTC_LIB_COMP * ulci) /* kicad lib print */
{
 if(
    (ulci == 0) ||			/* null lib component pointer check */
    (ustc_fo == 0)			/* null output file pointer */
 ) {
    return(0);
 }
 if(ulci->name == 0) {			/* kicad lib comp name null pointer check */
    return(0);
 }
 if(ustc_nl_print > 0) {
    fprintf(
	ustc_fo,			/* output file structure */
	"#\r\n# %s\r\n#\r\n", 		/* format */
	ulci->name			/* component name */
    );
 } else {
    fprintf(
	ustc_fo,			/* output file structure */
        "#\n# %s\n#\n",	 		/* format */
	ulci->name			/* component name */
    );
 }
 u_int8_t * pnumstr;			/* pin number visible string */
 if(ulci->pinnumvis > 0) {		/* pin number visible */
    pnumstr = (u_int8_t *) "Y";		/* pin number visible string */
 } else {
    pnumstr = (u_int8_t *) "N";		/* pin number invisible string  */
 }
 u_int8_t * pnamstr;			/* pin name visible string */
 if(ulci->pinnamvis > 0) {		/* pin name visible check */
    pnamstr = (u_int8_t *) "Y";		/* pin name visible string */
 } else {
    pnamstr = (u_int8_t *) "N";		/* pin name invisible string */
 }
 u_int8_t * lstr;			/* unit lock */
 if(ulci->unitlock == USTC_LIB_COMP_UNITLOCK_LOCK) { /* unit lock or swap disable */
    lstr = (u_int8_t *) "L";		/* unit lock string */
 } else
 if(ulci->unitlock == USTC_LIB_COMP_UNITLOCK_FIX) {
    lstr = (u_int8_t *) "F";		/* unit swapable */
 } else
 if(ulci->unitlock == USTC_LIB_COMP_UNITLOCK_FIXOLD) {
    lstr = (u_int8_t *) "0";		/* unit swapable */
 } else {
    lstr = (u_int8_t *) "F";		/* unit swapable */
 }
 u_int8_t * pstr;			/* power string */
 if(ulci->power > 0) {			/* component power check */
    pstr = (u_int8_t *) "P";		/* component power string */
 } else {
    pstr = (u_int8_t *) "N";		/* component normal string */
 }
 fprintf(				/* print comp information */
    ustc_fo,				/* output file structure pointer */
    "DEF %s %s %d %d %s %s %d %s %s",
    ulci->name,				/* name */
    ulci->reference,			/* reference */
    ulci->unused,			/* unused */
    ulci->offset,			/* offset */
    pnumstr,				/* pin number visible string */
    pnamstr,				/* pin name visible string */
    ulci->units,			/* units */
    lstr,				/* lock string */
    pstr				/* power string */
 );
 if(ustc_nl_print > 0) {
    fprintf(ustc_fo, "\r\n");
 } else {
    fprintf(ustc_fo, "\n");
 }
 int rvl;				/* return code */
 rvl = 1;				/* return code start value */
 if(ulci->alcount > 0) {		/* alias count check */
    if(ulci->alias + ulci->alcount - 1 >= ustc_lib_alias_count) {
	ustc_error(
	    "Out of alias buffer error, component name {%s},"
	    "alis number {%d},alis count {%d},alias buffer size {%d}\r\n",
	    ulci->name,			/* component namer */
	    ulci->alias,		/* alias reference */
	    ulci->alcount,		/* alias count */
	    ustc_lib_alias_count	/* alias buffer count */
	);
	return(0);
    }
    USTC_LIB_ALIAS * ulai;		/* alias pointer */
    ulai = ustc_lib_alias + ulci->alias; /* alias pointer set */
    if(ustc_lib_alias_print(		/* alias information print */
	    ulai, 			/* alias pointer */
	    ulci->alcount		/* alias count */
    ) == 0) {
        ustc_error("Aliaces print error, component name {%s}\r\n",
    	    ulci->name			/* kicad lib component name */
	);
	rvl = 0;			/* return code clear */
    }
 }
 if(ulci->ref != (u_int32_t)(-1)) {	/* field reference */
    if(ulci->ref >= ustc_lib_field_count) {
	if(rvl == 1) {
	    ustc_error(
		"KICAD LIB component {%s} reference field {%d}"
		"out of field buffer error, field buffer items count {%d}\r\n",
	        ulci->name,		/* kicad lib component name */
		ulci->ref,		/* kicad lib reference field */
		ustc_lib_field_count	/* kicad lib component count */
	    );
	    rvl = 0;			/* return code clear */
	}
    } else {
	USTC_LIB_FIELD * ulfi;		/* kicad lib field */
        ulfi = ustc_lib_field + ulci->ref; /* kicad lib field pointer set */
	if(ustc_lib_field_print(	/* kicad lib field print */
	    0,				/* reference field number */
	    ulfi			/* kicad lib field */
	) == 0) {			
	    if(rvl == 1) {		/* return code check */	
		ustc_error(
		    "KICAD LIB component {%s} reference field print error,"
		    "out of buffer\r\n",
		    ulci->name		/* kicad lib component name */
		);
		rvl = 0;		/* return code clear */
	    }
	}
    }
 }
 if(ulci->val !=  (u_int32_t)(-1)) {	/* kicad lib component value reference check */
    if(ulci->val >= ustc_lib_field_count) { /* value reference out of buffer check */
	if(rvl == 1) {		
	    ustc_error(
		"KICAD LIB component {%s} value field {%d} out of field buffer,"
		"buffes items count {%d}\r\n",
	        ulci->name,		/* kicad lib component name */
		ulci->val,		/* kicad lib value referebce */
	        ustc_lib_field_count	/* kicad lib field count */
	    );
	    rvl = 0;			/* retrurn code clear */
	}
    } else {
	USTC_LIB_FIELD * ulfi;		/* */
	ulfi = ustc_lib_field + ulci->val;
	if(ustc_lib_field_print(1,ulfi) == 0) {
	    ustc_error(
		"KICAD LIB component {%s} value field print error\r\n",
		ulci->name			/* name */
	    );
	    rvl = 0;
	}
    }
 }
 if(ulci->pcb !=  (u_int32_t)(-1)) {				/* field pcb footprint */
    if(ulci->pcb >= ustc_lib_field_count) {
	if(rvl == 1) {
	    ustc_error(
		"KICAD LIB component {%s} pcb footprint field {%d} out of field buffer,"
	        "buffes items count {%d}\r\n",
		ulci->name,			/* name */
	        ulci->pcb,
		ustc_lib_field_count
	    );
	    rvl = 0;
	}
    } else {
	USTC_LIB_FIELD * ulfi;
	ulfi = ustc_lib_field + ulci->pcb;
        if(ustc_lib_field_print(1,ulfi) == 0) {
	    if(rvl == 1) {
		ustc_error(
		    "KICAD LIB component {%s} pcb footprint field print error\r\n",
		    ulci->name			/* name */
		);
		rvl = 0;
	    }
	}
    }
 }
 if(ulci->diagram != (u_int32_t)(-1)) {			/* field diagram */
    if(ulci->diagram >= ustc_lib_field_count) {
	if(rvl == 1) {
	    ustc_error(
		"KICAD LIB component {%s} diagram field {%d} out of field buffer,"
		"buffes items count {%d}\r\n",
	        ulci->name,			/* name */
		ulci->diagram,
	        ustc_lib_field_count
	    );
	    rvl = 0;
	}
    } else {
	USTC_LIB_FIELD * ulfi;
	ulfi = ustc_lib_field + ulci->diagram;
	if(ustc_lib_field_print(1,ulfi) == 0) {
	    if(rvl == 1) {
		ustc_error(
		    "KICAD LIB component {%s} diagram field print error\r\n",
		    ulci->name			/* name */
		);
		rvl = 0;
	    }
	}
    }
 }
 u_int32_t fidx;
 for(fidx = 0; fidx < ulci->fcount; ++fidx) {
    u_int32_t fnum;
    fnum = ulci->field + fidx;		/* field reference */
    if(fnum >= ustc_lib_field_count) {
	if(rvl == 1) {
	    ustc_error(
		"KICAD LIB component {%s} field {%d} out of field buffer,"
		"buffes items count {%d}\r\n",
	        ulci->name,			/* name */
		fnum,
	        ustc_lib_field_count
	    );
	    rvl = 0;
	}
    }
    USTC_LIB_FIELD * ulfi;
    ulfi = ustc_lib_field + fidx;
    if(ustc_lib_field_print(4+fidx,ulfi) == 0) {
	if(rvl == 1) {
	    ustc_error(
		"KICAD LIB component {%s} field print error\r\n",
		ulci->name			/* name */
	    );
	    rvl = 0;
	}
    }
 }
 if(ulci->dcount > 0 || ulci->pcount > 0) {
    fprintf(ustc_fo, "DRAW");
    if(ustc_nl_print > 0) {
	fprintf(ustc_fo, "\r\n");
    } else {
	fprintf(ustc_fo, "\n");
    }
 }
 u_int32_t didx;
 for(didx = 0; didx < ulci->dcount; ++didx) {
    u_int32_t dnum;
    dnum = ulci->draw + didx;
    if(dnum >= ustc_lib_draw_count) {
	if(rvl == 1) {
	    ustc_error(
		"KICAD LIB draw out of buffer error, component name {%s},"
		"draw item number {%d}, draw item buffer count {%d}\r\n",
		ulci->name,			/* name */
		dnum,
		ustc_lib_draw_count
	    );
	    rvl = 0;
	}
    }
    USTC_LIB_DRAW * uldi;
    uldi = ustc_lib_draw + dnum;
    if(ustc_lib_draw_print(uldi) == 0) {
	if(rvl == 1) {
	    ustc_error(
		"KICAD LIB draw element print error, component name {%s},"
		"draw element number {%d}\r\n",
		ulci->name,			/* name */
		dnum
	    );
	    rvl = 0;
	}
    }
 }
 u_int32_t pidx;
 for(pidx = 0; pidx < ulci->pcount; ++pidx) {
    u_int32_t pnum;
    pnum = ulci->pin + pidx;
    if(pnum >= ustc_lib_pin_count) {
	if(rvl == 1) {
	    ustc_error(
		"KICAD LIB pin out of buffer error, component name {%s},"
		"pin number {%d}, pin buffer count {%d}\r\n",
		ulci->name,			/* name */
		pnum,
		ustc_lib_pin_count
	    );
	    rvl = 0;
	}
    }
    USTC_LIB_PIN * ulpi;
    ulpi = ustc_lib_pin + pnum;
    if(ustc_lib_pin_print(ulpi) == 0) {
	if(rvl == 1) {
	    ustc_error(
		"KICAD LIB pin print error, component name {%s},"
		"pin number {%d}\r\n",
		ulci->name,		/* name */
		pnum
	    );
	    rvl = 0;
	}
    }
 }
 if(ulci->dcount > 0 || ulci->pcount > 0) {
    fprintf(ustc_fo, "ENDDRAW");
    if(ustc_nl_print > 0) {
	fprintf(ustc_fo, "\r\n");
    } else {
	fprintf(ustc_fo, "\n");
    }
 }
 fprintf(ustc_fo, "ENDDEF");
 if(ustc_nl_print > 0) {
    fprintf(ustc_fo, "\r\n");
 } else {
    fprintf(ustc_fo, "\n");
 }
 return(1);
}
int ustc_lib_comps_print(u_int32_t crnum)
{
 int rvl;				/* return code */
 rvl = 1;				/* start return code */
 u_int32_t cnum;			/* component number */
 for(cnum = 0; cnum < ustc_lib_comp_count; ++cnum) { /* component loop */
    if(cnum == crnum) {			/* component number check */
	continue;			/* next component */
    }
    USTC_LIB_COMP * ulci;		/* lib component */
    ulci = ustc_lib_comp + cnum;	/* lib component set pointer */
    if(ustc_lib_comp_print(ulci) == 0) { /* component print */
	rvl = 0;			/* return code clear */
    }
 }
 fprintf(ustc_fo, "#");
 if(ustc_nl_print > 0) {
    fprintf(ustc_fo, "\r\n");
 } else {
    fprintf(ustc_fo, "\n");
 }
 fprintf(ustc_fo, "#End Library");
 if(ustc_nl_print > 0) {
    fprintf(ustc_fo, "\r\n");
 } else {
    fprintf(ustc_fo, "\n");
 }
 return(rvl);
}
int ustc_lib_header_free(USTC_LIB_HEADER * uli)
{
 if(uli == 0) {				/* kicad lib header pointer check */
    return(0);
 }
 if(uli->header == 0) {			/* buffer pointer check */
    return(0);
 }
 free(uli->header);			/* buffer free */
 uli->header = 0;			/* buffer pointer clear */
 return(1);
}
int ustc_lib_header_read(USTC_LIB_HEADER * uli,u_int8_t * buf, u_int32_t size) /* lib header read */
{
 if(uli == 0) {				/* null lib header pointer */
    return(0);
 }
 u_int8_t cut;				/* string cut flag */
 while(1) {
    if(ustc_read(buf, size, &cut) == 0) {
	ustc_error("Error read LIB header\r\n");
	return(0);
    }
    if(buf[0] == '\0') {
	continue;
    } else {
	break;
    }
 }
 int pos;				/* buffer position */
 pos = 0;				/* start buffer position */
 if(ustc_cmp(buf,"EESchema-LIBRARY", &pos) == 0) {
    ustc_error("Wait EESchema-LIBRARY, readed {%s}\r\n",
	buf + pos
    );
    return(0);
 }
 if(ustc_cmp(buf,"Version", &pos) == 0) { /* skip Version */	
    ustc_error("Wait Version, readed {%s}\r\n",
	buf + pos
    );
    return(0);
 }
 u_int8_t ird;				/* readed flag */
 int ival;				/* integer value */
 if(buf[pos] == '.') {
    uli->versionhi = (u_int8_t)(-1);	/* version hi undefined */
 } else {
    ival = 0;				/* integer value clear */
    ird = 0;				/* readed flag clear */
    if(ustc_int(buf,&ival,&pos,&ird) == 0) {
	ustc_error("Version hi read error\r\n");
	return(0);
    } else {
	if(ird == 0) {
	    uli->versionhi = (u_int8_t)(-1);	/* version hi not readed */
	} else {
	    uli->versionhi = ival;	/* version hi write */
	}
    }
 }
 if(buf[pos] == '.') {
    pos += 1;				/* version separator skip */
    ival = 0;				/* integer value clear */
    ird = 0;				/* readed flag clear */
    if(ustc_int(buf,&ival,&pos,&ird) == 0) {
	ustc_error("Version lo read error\r\n");
	return(0);
    } else {
	if(ird == 0) {
	    uli->versionlo = (u_int8_t)(-1);	/* version hi not readed */
	} else {
	    uli->versionlo = ival;	/* version lo write */
	}
    }
 } else {
    uli->versionlo = (u_int8_t)(-1);	/* version lo not defined */
 }
 if(ustc_cmp(buf,"Date:", &pos) == 0) { /* skip Version */	
    ustc_error("Wait Date:, readed {%s}\r\n",
	buf + pos
    );
    return(0);
 }
 ival = 0;				/* day default */	
 ird = 0;				/* readed flag clear */	
 if(ustc_int(buf,&ival,&pos,&ird) == 0) { /* read day */		
    ustc_error("Day read error\r\n");
    return(0);
 } else {
    if(ird == 0) {
        uli->day = (u_int8_t)(-1);	/* day clear */
    } else {
        uli->day = ival;		/* day write */
    }
 }
 if(buf[pos] == '/') {
    pos += 1;				/* day&month separator skip */
 } else {
    ustc_error("Wait day month separator, readed {%s}\r\n", buf + pos);
    return(0);
 }
 ival = 0;				/* integer value clear */
 ird = 0;				/* readed flag clear */
 if(ustc_int(buf, &ival, &pos, &ird) == 0) { /* read month */
    ustc_error("Month read error\r\n");
    return(0);
 } else {
    if(ird == 0) {
        uli->mon = (u_int8_t)(-1);	/* month not readed */
    } else {
        uli->mon = ival;		/* write month */
    }
 }
 if(buf[pos] == '/') {
    pos += 1;				/* mont year skip */
 } else {
    ustc_error("Wait month/year separator, readed {%s}\r\n", buf + pos);
    return(0);
 }
 ival = 0;				/* integer value clear */
 ird = 0;				/* readed value clear */
 if(ustc_int(buf,&ival,&pos,&ird) == 0) { /* year read */
    ustc_error("Year read error\r\n");
    return(0);
 } else {
    if(ird == 0) {
        uli->year = (u_int32_t)(-1);	/* year clear */
    } else {
        uli->year = ival;		/* year write */
    }
 }
 if(
    (buf[pos] == '-') || 
    (buf[pos] == ' ')
 ) {
    pos += 1;				/* skip year&hour separator */
 } else {
    ustc_error("Wait year/hour separator, readed {%s}\r\n", buf + pos);
    return(0);
 }
 ival = 0;				/* integer value clear */
 ird = 0;				/* readed flag clear */
 if(ustc_int(buf,&ival,&pos,&ird) == 0) {
    ustc_error("Hour read error\r\n");
    return(0);
 } else {
    if(ird == 0) {
        uli->hour = (u_int8_t)(-1);	/* hour clear */
    } else {
        uli->hour = ival;		/* write hour */
    }
 }
 if(buf[pos] == ':') {
    pos += 1;				/* hour & minumte separator skip */
 } else {
    ustc_error("Wait hour/minute separator, readed {%s}\r\n", buf + pos);
    return(0);
 }
 ival = 0;				
 ird = 0;
 if(ustc_int(buf,&ival,&pos,&ird) == 0) {
    ustc_error("Minute read error\r\n");
    return(0);
 } else {
    if(ird == 0) {
        uli->min = (u_int8_t)(-1);	/* minute clear */
    } else {
        uli->min = ival;		/* minute write */
    }
 }
 if(buf[pos] == ':') {
    pos += 1;				/* minute & second separator skip */
 } else {
    ustc_error("Wait minute/second separator, readed {%s}\r\n", buf + pos);
    return(0);
 }
 ival = 0;
 ird = 0;
 if(ustc_int(buf,&ival,&pos,&ird) == 0) {
    ustc_error("Minute read error\r\n");
    return(0);
 } else {
    if(ird == 0) {
        uli->sec = (u_int8_t)(-1);	/* second clear */
    } else {
        uli->sec = ival;		/* second write */
    }
 }
 return(1);
}
int ustc_lib_alias_alloc(u_int32_t count) /* allocate kicad lib alias */
{
 if(count <= ustc_lib_alias_count) {
    count = ustc_lib_alias_count + count; /* calculate cad aliass count */
 }
 USTC_LIB_ALIAS * salias;		
 salias = ustc_lib_alias;		/* save alias buffer pointer */
 ustc_lib_alias = (USTC_LIB_ALIAS *) malloc(sizeof(USTC_LIB_ALIAS) * count);
 if(ustc_lib_alias == 0) {		/* aloas buffer allocation check */
    ustc_lib_alias = salias;		/* restore alias pointer */
    return(0);
 }
 int rvl;				/* return code */
 rvl = 1;				/* return code start value */
 if(salias != 0) {
    u_int32_t alnum;			/* alias number */
    for(alnum = 0; alnum < ustc_lib_alias_count; ++alnum) {
	USTC_LIB_ALIAS * dlai;		/* destination alias pointer */
	USTC_LIB_ALIAS * slai;		/* source alias pointer */
	dlai = ustc_lib_alias + alnum;	/* set destination alias pointer */
	slai = salias + alnum;		/* set source alias pointer */
	*dlai = *slai;			/* copy alias information */
    }
    while(alnum < count) {
	USTC_LIB_ALIAS * dlai;		/* destination alias pointer */
	dlai = ustc_lib_alias + alnum;	/* set destination alias pointer */
	alnum += 1;			/* eqipot next number */
	if(ustc_lib_alias_clear(dlai) == 0) {
	    rvl = 0;
    	}
    }
 }
 if(salias != 0) {
    free(salias);			/* free saved alias buffer pointer */
    salias = 0;				/* quipot buffer pointer clear */
 }
 ustc_lib_alias_count = count;
 return(rvl);
}
int ustc_lib_field_alloc(u_int32_t count) /* allocate kicad lib field */
{
 if(count <= ustc_lib_field_count) {
    count = ustc_lib_field_count + count; /* calculate cad fields count */
 }
 USTC_LIB_FIELD * sfield;		
 sfield = ustc_lib_field;		/* save field buffer pointer */
 ustc_lib_field = (USTC_LIB_FIELD *) malloc(sizeof(USTC_LIB_FIELD) * count);
 if(ustc_lib_field == 0) {		/* buffer allocation check */
    ustc_lib_field = sfield;		/* buffer pointer restore */
    return(0);
 }
 int rvl;				/* return code */
 rvl = 1;				/* return code start value */
 if(sfield != 0) {
    u_int32_t fnum;			/* field number */
    for(fnum = 0; fnum < ustc_lib_field_count; ++fnum) {
	USTC_LIB_FIELD * dlfi;		/* destination field pointer */
	USTC_LIB_FIELD * slfi;		/* source field pointer */
	dlfi = ustc_lib_field + fnum;	/* set destination field pointer */
	slfi = sfield + fnum;		/* set source field pointer */
	*dlfi = *slfi;			/* copy field information */
    }
    while(fnum < count) {
	USTC_LIB_FIELD * dlfi;		/* destination field pointer */
	dlfi = ustc_lib_field + fnum;	/* set destination field pointer */
	fnum += 1;			/* eqipot next number */
	if(ustc_lib_field_clear(dlfi) == 0) {
	    rvl = 0;
    	}
    }
 }
 if(sfield != 0) {
    free(sfield);			/* free saved field buffer pointer */
    sfield = 0;				/* quipot buffer pointer clear */
 }
 ustc_lib_field_count = count;
 return(rvl);
}
int ustc_lib_poly_alloc(u_int32_t count) /* allocate kicad lib poly */
{
 if(count <= ustc_lib_poly_count) {
    count = ustc_lib_poly_count + count; /* calculate cad polys count */
 }
 USTC_LIB_POLY * spoly;		
 spoly = ustc_lib_poly;			/* save poly buffer pointer */
 ustc_lib_poly = (USTC_LIB_POLY *) malloc(sizeof(USTC_LIB_POLY) * count);
 if(ustc_lib_poly == 0) {		/* lib poly buffer allocation check */
    ustc_lib_poly = spoly;		/* lib poly buffer pointer restore */
    return(0);
 }
 int rvl;				/* return code */
 rvl = 1;				/* return code start value */
 if(spoly != 0) {
    u_int32_t pnum;			/* poly number */
    for(pnum = 0; pnum < ustc_lib_poly_count; ++pnum) {
	USTC_LIB_POLY * dlpi;		/* destination poly pointer */
	USTC_LIB_POLY * slpi;		/* source poly pointer */
	dlpi = ustc_lib_poly + pnum;	/* set destination poly pointer */
	slpi = spoly + pnum;		/* set source poly pointer */
	*dlpi = *slpi;			/* copy poly information */
    }
    while(pnum < count) {
	USTC_LIB_POLY * dlpi;		/* destination poly pointer */
	dlpi = ustc_lib_poly + pnum;	/* set destination poly pointer */
	pnum += 1;			/* eqipot next number */
	if(ustc_lib_poly_clear(dlpi) == 0) {
	    rvl = 0;
    	}
    }
 }
 if(spoly != 0) {
    free(spoly);			/* free saved poly buffer pointer */
    spoly = 0;				/* quipot buffer pointer clear */
 }
 ustc_lib_poly_count = count;
 return(rvl);
}
int ustc_lib_rect_alloc(u_int32_t count) /* allocate kicad lib rect */
{
 if(count <= ustc_lib_rect_count) {
    count = ustc_lib_rect_count + count; /* calculate cad rects count */
 }
 USTC_LIB_RECT * srect;		
 srect = ustc_lib_rect;			/* save rect buffer pointer */
 ustc_lib_rect = (USTC_LIB_RECT *) malloc(sizeof(USTC_LIB_RECT) * count);
 if(ustc_lib_rect == 0) {		/* allocatin check */
    ustc_lib_rect = srect;		/* buffer pointer restore */
    return(0);
 }
 int rvl;				/* return code */
 rvl = 1;				/* return code start value */
 if(srect != 0) {
    u_int32_t rnum;			/* rect number */
    for(rnum = 0; rnum < ustc_lib_rect_count; ++rnum) {
	USTC_LIB_RECT * dlri;		/* destination rect pointer */
	USTC_LIB_RECT * slri;		/* source rect pointer */
	dlri = ustc_lib_rect + rnum;	/* set destination rect pointer */
	slri = srect + rnum;		/* set source rect pointer */
	*dlri = *slri;			/* copy rect information */
    }
    while(rnum < count) {
	USTC_LIB_RECT * dlri;		/* destination rect pointer */
	dlri = ustc_lib_rect + rnum;	/* set destination rect pointer */
	rnum += 1;			/* eqipot next number */
	if(ustc_lib_rect_clear(dlri) == 0) {
	    rvl = 0;
    	}
    }
 }
 if(srect != 0) {
    free(srect);			/* free saved rect buffer pointer */
    srect = 0;				/* quipot buffer pointer clear */
 }
 ustc_lib_rect_count = count;
 return(rvl);
}
int ustc_lib_ring_alloc(u_int32_t count) /* allocate kicad lib ring */
{
 if(count <= ustc_lib_ring_count) {
    count = ustc_lib_ring_count + count; /* calculate cad rings count */
 }
 USTC_LIB_RING * sring;		
 sring = ustc_lib_ring;			/* save ring buffer pointer */
 ustc_lib_ring = (USTC_LIB_RING *) malloc(sizeof(USTC_LIB_RING) * count);
 if(ustc_lib_ring == 0) {		/* allocation check */
    ustc_lib_ring = sring;		/* pointer restore */
    return(0);
 }
 int rvl;				/* return code */
 rvl = 1;				/* return code start value */
 if(sring != 0) {
    u_int32_t rnum;			/* ring number */
    for(rnum = 0; rnum < ustc_lib_ring_count; ++rnum) {
	USTC_LIB_RING * dlri;		/* destination ring pointer */
	USTC_LIB_RING * slri;		/* source ring pointer */
	dlri = ustc_lib_ring + rnum;	/* set destination ring pointer */
	slri = sring + rnum;		/* set source ring pointer */
	*dlri = *slri;			/* copy ring information */
    }
    while(rnum < count) {
	USTC_LIB_RING * dlri;		/* destination ring pointer */
	dlri = ustc_lib_ring + rnum;	/* set destination ring pointer */
	rnum += 1;			/* eqipot next number */
	if(ustc_lib_ring_clear(dlri) == 0) {
	    rvl = 0;
    	}
    }
 }
 if(sring != 0) {
    free(sring);			/* free saved ring buffer pointer */
    sring = 0;				/* quipot buffer pointer clear */
 }
 ustc_lib_ring_count = count;
 return(rvl);
}
int ustc_lib_arc_alloc(u_int32_t count) /* allocate kicad lib arc */
{
 if(count <= ustc_lib_arc_count) {
    count = ustc_lib_arc_count + count; /* calculate cad arcs count */
 }
 USTC_LIB_ARC * sarc;		
 sarc = ustc_lib_arc;			/* save arc buffer pointer */
 ustc_lib_arc = (USTC_LIB_ARC *) malloc(sizeof(USTC_LIB_ARC) * count);
 if(ustc_lib_arc == 0) {		/* buffer allocation check */
    ustc_lib_arc = sarc;		/* buffer pointer restore */
    return(0);
 }
 int rvl;				/* return code */
 rvl = 1;				/* return code start value */
 if(sarc != 0) {
    u_int32_t anum;			/* arc number */
    for(anum = 0; anum < ustc_lib_arc_count; ++anum) {
	USTC_LIB_ARC * dlai;		/* destination arc pointer */
	USTC_LIB_ARC * slai;		/* source arc pointer */
	dlai = ustc_lib_arc + anum;	/* set destination arc pointer */
	slai = sarc + anum;		/* set source arc pointer */
	*dlai = *slai;			/* copy arc information */
    }
    while(anum < count) {
	USTC_LIB_ARC * dlai;		/* destination arc pointer */
	dlai = ustc_lib_arc + anum;	/* set destination arc pointer */
	anum += 1;			/* eqipot next number */
	if(ustc_lib_arc_clear(dlai) == 0) {
	    rvl = 0;
    	}
    }
 }
 if(sarc != 0) {
    free(sarc);				/* free saved arc buffer pointer */
    sarc = 0;				/* quipot buffer pointer clear */
 }
 ustc_lib_arc_count = count;
 return(rvl);
}
int ustc_lib_text_alloc(u_int32_t count) /* allocate kicad lib text */
{
 if(count <= ustc_lib_text_count) {
    count = ustc_lib_text_count + count; /* calculate cad texts count */
 }
 USTC_LIB_TEXT * stext;		
 stext = ustc_lib_text;			/* save text buffer pointer */
 ustc_lib_text = (USTC_LIB_TEXT *) malloc(sizeof(USTC_LIB_TEXT) * count);
 if(ustc_lib_text == 0) {		/* buffer allocation check */
    ustc_lib_text = stext;		/* bffer pointer restore */
    return(0);
 }
 int rvl;				/* return code */
 rvl = 1;				/* return code start value */
 if(stext != 0) {
    u_int32_t tnum;			/* text number */
    for(tnum = 0; tnum < ustc_lib_text_count; ++tnum) {
	USTC_LIB_TEXT * dlti;		/* destination text pointer */
	USTC_LIB_TEXT * slti;		/* source text pointer */
	dlti = ustc_lib_text + tnum;	/* set destination text pointer */
	slti = stext + tnum;		/* set source text pointer */
	*dlti = *slti;			/* copy text information */
    }
    while(tnum < count) {
	USTC_LIB_TEXT * dlti;		/* destination text pointer */
	dlti = ustc_lib_text + tnum;	/* set destination text pointer */
	tnum += 1;			/* eqipot next number */
	if(ustc_lib_text_clear(dlti) == 0) {
	    rvl = 0;
    	}
    }
 }
 if(stext != 0) {
    free(stext);			/* free saved text buffer pointer */
    stext = 0;				/* quipot buffer pointer clear */
 }
 ustc_lib_text_count = count;
 return(rvl);
}
int ustc_lib_draw_alloc(u_int32_t count) /* allocate kicad lib draw */
{
 if(count <= ustc_lib_draw_count) {
    count = ustc_lib_draw_count + count; /* calculate cad draws count */
 }
 USTC_LIB_DRAW * sdraw;		
 sdraw = ustc_lib_draw;			/* save draw buffer pointer */
 ustc_lib_draw = (USTC_LIB_DRAW *) malloc(sizeof(USTC_LIB_DRAW) * count);
 if(ustc_lib_draw == 0) {		/* buffer allocation check */
    ustc_lib_draw = sdraw;		/* buffer pointer restore */
    return(0);
 }
 int rvl;				/* return code */
 rvl = 1;				/* return code start value */
 if(sdraw != 0) {
    u_int32_t dnum;			/* draw number */
    for(dnum = 0; dnum < ustc_lib_draw_count; ++dnum) {
	USTC_LIB_DRAW * dldi;		/* destination draw pointer */
	USTC_LIB_DRAW * sldi;		/* source draw pointer */
	dldi = ustc_lib_draw + dnum;	/* set destination draw pointer */
	sldi = sdraw + dnum;		/* set source draw pointer */
	*dldi = *sldi;			/* copy draw information */
    }
    while(dnum < count) {
	USTC_LIB_DRAW * dldi;		/* destination draw pointer */
	dldi = ustc_lib_draw + dnum;	/* set destination draw pointer */
	dnum += 1;			/* eqipot next number */
	if(ustc_lib_draw_clear(dldi) == 0) {
	    rvl = 0;
    	}
    }
 }
 if(sdraw != 0) {
    free(sdraw);			/* free saved draw buffer pointer */
    sdraw = 0;				/* quipot buffer pointer clear */
 }
 ustc_lib_draw_count = count;
 return(rvl);
}
int ustc_lib_pin_alloc(u_int32_t count) /* allocate kicad lib pin */
{
 if(count <= ustc_lib_pin_count) {
    count = ustc_lib_pin_count + count; /* calculate cad pins count */
 }
 USTC_LIB_PIN * spin;			/* saved buffer pointer */
 spin = ustc_lib_pin;			/* save pin buffer pointer */
 ustc_lib_pin = (USTC_LIB_PIN *) malloc(sizeof(USTC_LIB_PIN) * count);
 if(ustc_lib_pin == 0) {		/* buffer allocation check */
    ustc_lib_pin = spin;		/* buffer pointer restore */
    return(0);
 }
 int rvl;				/* return code */
 rvl = 1;				/* return code start value */
 if(spin != 0) {
    u_int32_t pnum;			/* pin number */
    for(pnum = 0; pnum < ustc_lib_pin_count; ++pnum) {
	USTC_LIB_PIN * dlpi;		/* destination pin pointer */
	USTC_LIB_PIN * slpi;		/* source pin pointer */
	dlpi = ustc_lib_pin + pnum;	/* set destination pin pointer */
	slpi = spin + pnum;		/* set source pin pointer */
	*dlpi = *slpi;			/* copy pin information */
    }
    while(pnum < count) {
	USTC_LIB_PIN * dlpi;		/* destination pin pointer */
	dlpi = ustc_lib_pin + pnum;	/* set destination pin pointer */
	pnum += 1;			/* eqipot next number */
	if(ustc_lib_pin_clear(dlpi) == 0) {
	    rvl = 0;
    	}
    }
 }
 if(spin != 0) {
    free(spin);				/* free saved pin buffer pointer */
    spin = 0;				/* quipot buffer pointer clear */
 }
 ustc_lib_pin_count = count;
 return(rvl);
}
int ustc_lib_comp_alloc(u_int32_t count) /* allocate kicad lib comp */
{
 if(count <= ustc_lib_comp_count) {
    count = ustc_lib_comp_count + count; /* calculate cad comps count */
 }
 USTC_LIB_COMP * scomp;			/* saved buffer pointer */
 scomp = ustc_lib_comp;			/* save comp buffer pointer */
 ustc_lib_comp = (USTC_LIB_COMP *) malloc(sizeof(USTC_LIB_COMP) * count);
 if(ustc_lib_comp == 0) {		/* buffer allocation check */
    ustc_lib_comp = scomp;		/* buffer pointer restore */
    return(0);
 }
 int rvl;				/* return code */
 rvl = 1;				/* return code start value */
 if(scomp != 0) {
    u_int32_t cnum;			/* comp number */
    for(cnum = 0; cnum < ustc_lib_comp_count; ++cnum) {
	USTC_LIB_COMP * dlci;		/* destination comp pointer */
	USTC_LIB_COMP * slci;		/* source comp pointer */
	dlci = ustc_lib_comp + cnum;	/* set destination comp pointer */
	slci = scomp + cnum;		/* set source comp pointer */
	*dlci = *slci;			/* copy comp information */
    }
    while(cnum < count) {
	USTC_LIB_COMP * dlci;		/* destination comp pointer */
	dlci = ustc_lib_comp + cnum;	/* set destination comp pointer */
	cnum += 1;			/* eqipot next number */
	if(ustc_lib_comp_clear(dlci) == 0) {
	    rvl = 0;
    	}
    }
 }
 if(scomp != 0) {
    free(scomp);			/* free saved comp buffer pointer */
    scomp = 0;				/* quipot buffer pointer clear */
 }
 ustc_lib_comp_count = count;
 return(rvl);
}
int ustc_lib_comp_num(u_int8_t * name)
{
 if(name == 0) {			/* name pointer check */
    return(-1);				/* component not found */
 }
 u_int32_t cnum;			/* comp number */
 for(cnum = 0; cnum < ustc_lib_comp_count; ++cnum) {
    USTC_LIB_COMP * ulci;		/* comp pointer */
    ulci = ustc_lib_comp + cnum;	/* set comp pointer */
    if(ulci->name != 0) {		/* component name pointer check */
	if(strcmp((char *)ulci->name, (char *)name) == 0) {
	    return(cnum);
	}
    } 
 }
 return(-1);				/* component not found */
}
int ustc_lib_alias_free(void)		/* free cad alias */
{
 if(ustc_lib_alias != 0) {
    u_int32_t alnum;			/* alias number */
    for(alnum = 0; alnum < ustc_lib_alias_count; ++alnum) {
	USTC_LIB_ALIAS * ulai;
	ulai = ustc_lib_alias + alnum; /* set destination alias pointer */
	if(ulai->name != 0) {
	    free(ulai->name);		/* name free */
	    ulai->name = 0;		/* name clear pointer */
	}
    }
    free(ustc_lib_alias);		/* free alias buffer */
    ustc_lib_alias = 0;			/* clear alias buffer pointer */
 }
 ustc_lib_alias_count = 0;
 return(1);
}
int ustc_lib_field_free(void)		/* free lib field */
{
 if(ustc_lib_field != 0) {
    u_int32_t fnum;			/* field number */
    for(fnum = 0; fnum < ustc_lib_field_count; ++fnum) {
	USTC_LIB_FIELD * ulfi;
	ulfi = ustc_lib_field + fnum; /* set destination field pointer */
	if(ulfi->name != 0) {
	    free(ulfi->name);		/* name free */
	    ulfi->name = 0;		/* name clear pointer */
	}
    }
    free(ustc_lib_field);		/* free field buffer */
    ustc_lib_field = 0;			/* clear field buffer pointer */
 }
 ustc_lib_field_count = 0;
 return(1);
}
int ustc_lib_poly_free(void)		/* free lib poly */
{
 if(ustc_lib_poly != 0) {
    free(ustc_lib_poly);		/* free poly buffer */
    ustc_lib_poly = 0;			/* clear poly buffer pointer */
 }
 ustc_lib_poly_count = 0;
 return(1);
}
int ustc_lib_rect_free(void)		/* free lib rect */
{
 if(ustc_lib_rect != 0) {
    free(ustc_lib_rect);		/* free rect buffer */
    ustc_lib_rect = 0;			/* clear rect buffer pointer */
 }
 ustc_lib_rect_count = 0;
 return(1);
}
int ustc_lib_ring_free(void)		/* free lib ring */
{
 if(ustc_lib_ring != 0) {
    free(ustc_lib_ring);		/* free ring buffer */
    ustc_lib_ring = 0;			/* clear ring buffer pointer */
 }
 ustc_lib_ring_count = 0;
 return(1);
}
int ustc_lib_arc_free(void)		/* free lib arc */
{
 if(ustc_lib_arc != 0) {
    free(ustc_lib_arc);			/* free lib buffer */
    ustc_lib_arc = 0;			/* clear lib buffer pointer */
 }
 ustc_lib_arc_count = 0;
 return(1);
}
int ustc_lib_text_free(void)		/* free lib text */
{
 if(ustc_lib_text != 0) {
    free(ustc_lib_text);		/* free text buffer */
    ustc_lib_text = 0;			/* clear ring buffer pointer */
 }
 ustc_lib_text_count = 0;
 return(1);
}
int ustc_lib_draw_free(void)		/* free lib draw */
{
 if(ustc_lib_draw != 0) {
    free(ustc_lib_draw);		/* free draw buffer */
    ustc_lib_draw = 0;			/* clear draw buffer pointer */
 }
 ustc_lib_draw_count = 0;
 return(1);
}
int ustc_lib_pin_free(void)		/* free lib pins */
{
 if(ustc_lib_pin != 0) {
    u_int32_t pnum;
    for(pnum = 0; pnum < ustc_lib_pin_count; ++pnum) {
	USTC_LIB_PIN * dlpi;		/* destination pin pointer */
	dlpi = ustc_lib_pin + pnum;	/* set destination pin pointer */
	if(dlpi->name != 0) {
	    free(dlpi->name);		/* name free */
	    dlpi->name = 0;		/* name clear */
	}
    }
    free(ustc_lib_pin);			/* free pin buffer */
    ustc_lib_pin = 0;			/* clear pin buffer pointer */
 }
 ustc_lib_pin_count = 0;
 return(1);
}
int ustc_lib_comp_free(void)		/* free lib comp */
{
 if(ustc_lib_comp != 0) {
    u_int32_t cnum;
    for(cnum = 0; cnum < ustc_lib_comp_count; ++cnum) {
	USTC_LIB_COMP * dlci;		/* destination comp pointer */
	dlci = ustc_lib_comp + cnum;	/* set destination comp pointer */
	if(dlci->name != 0) {
	    free(dlci->name);		/* name free */
	    dlci->name = 0;		/* name clear */
	}
	if(dlci->reference != 0) {
	    free(dlci->reference);	/* reference free */
	    dlci->reference = 0;	/* reference clear */
	}
    }
    free(ustc_lib_comp);		/* free comp buffer */
    ustc_lib_comp = 0;			/* clear comp buffer pointer */
 }
 ustc_lib_comp_count = 0;
 return(1);
}
int ustc_lib_alias_add(u_int32_t *alnum, u_int8_t * name) /* kicad lib alias add */
{
 if(
    (alnum == 0) ||			/* null alias number pointer */
    (name == 0)				/* null cad alias name pointer */
 ) {
    return(0);
 }
 int rvl; 				/* return code */
 rvl = 1;				/* start return code */
 if(*alnum >= ustc_lib_alias_count) {	/* allocate cad alias check */
    if(ustc_lib_alias_alloc(100) == 0) {
	rvl = 0;			/* allocation error */
    }
    if(rvl == 1) {
	if(*alnum >= ustc_lib_alias_count) { /* check allocation error */
	    rvl = 0;			/* allocation error */
	}
    }
    if(rvl == 0) {
    	ustc_error("Error cad alias allocate\r\n");
	return(0);
    }
 }
 USTC_LIB_ALIAS * dlai;			/* destination alias pointer */
 dlai = ustc_lib_alias + *alnum;	/* set destination alias pointer */
 int len;				/* buffer length */
 len = strlen((char *)name) + 1;	/* calculate cad alias length */
 dlai->name = (u_int8_t *) malloc(len); /* allocate buffer name */
 if(dlai->name == 0) {
    ustc_error("KICAD LIB alias name allocate error\r\n");
    return(0);
 } else {
    snprintf(
	(char *)dlai->name,		/* alias name */
	len,				/* buffer length */
	"%s",				/* format */
	name				/* alias name */
    );
 }
 *alnum += 1;				/* next alias number */
 return(1);
}
int ustc_lib_field_add(u_int32_t *fnum, USTC_LIB_FIELD * ulfi) /* kicad lib field add */
{
 if(
    (fnum == 0) ||			/* null field number pointer */
    (ulfi == 0)				/* null cad field name pointer */
 ) {
    return(0);
 }
 int rvl; 				/* return code */
 rvl = 1;				/* start return code */
 if(*fnum >= ustc_lib_field_count) {	/* allocate cad field check */
    if(ustc_lib_field_alloc(100) == 0) {
	rvl = 0;			/* allocation error */
    }
    if(rvl == 1) {
	if(*fnum >= ustc_lib_field_count) { /* check allocation error */
	    rvl = 0;			/* allocation error */
	}
    }
    if(rvl == 0) {
    	ustc_error("Error cad field allocate\r\n");
	return(0);
    }
 }
 USTC_LIB_FIELD * dlfi;			/* destination field pointer */
 dlfi = ustc_lib_field + *fnum;		/* set destination field pointer */
 *dlfi = *ulfi;
 *fnum += 1;				/* next field number */
 return(1);
}
int ustc_lib_poly_add(u_int32_t *pnum, int32_t x0, int32_t y0) /* kicad lib poly add */
{
 if(pnum == 0) {			/* null poly number pointer */
    return(0);
 }
 int rvl; 				/* return code */
 rvl = 1;				/* start return code */
 if(*pnum >= ustc_lib_poly_count) {	/* allocate cad poly check */
    if(ustc_lib_poly_alloc(100) == 0) {
	rvl = 0;			/* allocation error */
    }
    if(rvl == 1) {
	if(*pnum >= ustc_lib_poly_count) { /* check allocation error */
	    rvl = 0;			/* allocation error */
	}
    }
    if(rvl == 0) {
    	ustc_error("Error cad poly allocate\r\n");
	return(0);
    }
 }
 USTC_LIB_POLY * dlpi;			/* destination poly pointer */
 dlpi = ustc_lib_poly + *pnum;		/* set destination poly pointer */
 dlpi->x0 = x0;				/* point x position write */
 dlpi->y0 = y0;				/* point y position write */
 *pnum += 1;				/* next poly number */
 return(1);
}
int ustc_lib_rect_add(u_int32_t *rnum, USTC_LIB_RECT * ulri) /* kicad lib rect add */
{
 if(
    (rnum == 0) ||			/* null rect number pointer */
    (ulri == 0)				/* null cad rect name pointer */
 ) {
    return(0);
 }
 int rvl; 				/* return code */
 rvl = 1;				/* start return code */
 if(*rnum >= ustc_lib_rect_count) {	/* allocate cad rect check */
    if(ustc_lib_rect_alloc(100) == 0) {
	rvl = 0;			/* allocation error */
    }
    if(rvl == 1) {
	if(*rnum >= ustc_lib_rect_count) { /* check allocation error */
	    rvl = 0;			/* allocation error */
	}
    }
    if(rvl == 0) {
    	ustc_error("Error cad rect allocate\r\n");
	return(0);
    }
 }
 USTC_LIB_RECT * dlri;			/* destination rect pointer */
 dlri = ustc_lib_rect + *rnum;		/* set destination rect pointer */
 *dlri = *ulri;
 *rnum += 1;				/* next rect number */
 return(1);
}
int ustc_lib_ring_add(u_int32_t *rnum, USTC_LIB_RING * ulri) /* kicad lib ring add */
{
 if(
    (rnum == 0) ||			/* null ring number pointer */
    (ulri == 0)				/* null cad ring name pointer */
 ) {
    return(0);
 }
 int rvl; 				/* return code */
 rvl = 1;				/* start return code */
 if(*rnum >= ustc_lib_ring_count) {	/* allocate cad ring check */
    if(ustc_lib_ring_alloc(100) == 0) {
	rvl = 0;			/* allocation error */
    }
    if(rvl == 1) {
	if(*rnum >= ustc_lib_ring_count) { /* check allocation error */
	    rvl = 0;			/* allocation error */
	}
    }
    if(rvl == 0) {
    	ustc_error("Error cad ring allocate\r\n");
	return(0);
    }
 }
 USTC_LIB_RING * dlri;			/* destination ring pointer */
 dlri = ustc_lib_ring + *rnum;		/* set destination ring pointer */
 *dlri = *ulri;
 *rnum += 1;				/* next ring number */
 return(1);
}
int ustc_lib_arc_add(u_int32_t *anum, USTC_LIB_ARC * ulai) /* kicad lib arc add */
{
 if(
    (anum == 0) ||			/* null arc number pointer */
    (ulai == 0)				/* null cad arc name pointer */
 ) {
    return(0);
 }
 int rvl; 				/* return code */
 rvl = 1;				/* start return code */
 if(*anum >= ustc_lib_arc_count) {	/* allocate cad arc check */
    if(ustc_lib_arc_alloc(100) == 0) {
	rvl = 0;			/* allocation error */
    }
    if(rvl == 1) {
	if(*anum >= ustc_lib_arc_count) { /* check allocation error */
	    rvl = 0;			/* allocation error */
	}
    }
    if(rvl == 0) {
    	ustc_error("Error cad arc allocate\r\n");
	return(0);
    }
 }
 USTC_LIB_ARC * dlai;			/* destination arc pointer */
 dlai = ustc_lib_arc + *anum;		/* set destination arc pointer */
 *dlai = *ulai;
 *anum += 1;				/* next arc number */
 return(1);
}
int ustc_lib_text_add(u_int32_t *tnum, USTC_LIB_TEXT * ulti) /* kicad lib text add */
{
 if(
    (tnum == 0) ||			/* null text number pointer */
    (ulti == 0)				/* null cad text name pointer */
 ) {
    return(0);
 }
 int rvl; 				/* return code */
 rvl = 1;				/* start return code */
 if(*tnum >= ustc_lib_text_count) {	/* allocate cad text check */
    if(ustc_lib_text_alloc(100) == 0) {
	rvl = 0;			/* allocation error */
    }
    if(rvl == 1) {
	if(*tnum >= ustc_lib_text_count) { /* check allocation error */
	    rvl = 0;			/* allocation error */
	}
    }
    if(rvl == 0) {
    	ustc_error("Error cad text allocate\r\n");
	return(0);
    }
 }
 USTC_LIB_TEXT * dlti;			/* destination text pointer */
 dlti = ustc_lib_text + *tnum;		/* set destination text pointer */
 *dlti = *ulti;
 *tnum += 1;				/* next text number */
 return(1);
}
int ustc_lib_draw_add(u_int32_t *dnum, USTC_LIB_DRAW * uldi) /* kicad lib draw add */
{
 if(
    (dnum == 0) ||			/* null draw number pointer */
    (uldi == 0)				/* null cad draw name pointer */
 ) {
    return(0);
 }
 int rvl; 				/* return code */
 rvl = 1;				/* start return code */
 if(*dnum >= ustc_lib_draw_count) {	/* allocate cad draw check */
    if(ustc_lib_draw_alloc(100) == 0) {
	rvl = 0;			/* allocation error */
    }
    if(rvl == 1) {
	if(*dnum >= ustc_lib_draw_count) { /* check allocation error */
	    rvl = 0;			/* allocation error */
	}
    }
    if(rvl == 0) {
    	ustc_error("Error cad draw allocate\r\n");
	return(0);
    }
 }
 USTC_LIB_DRAW * dldi;			/* destination draw pointer */
 dldi = ustc_lib_draw + *dnum;		/* set destination draw pointer */
 *dldi = *uldi;
 *dnum += 1;				/* next draw number */
 return(1);
}
int ustc_lib_pin_add(u_int32_t *pnum, USTC_LIB_PIN * ulpi) /* kicad lib pin add */
{
 if(
    (pnum == 0) ||			/* null pin number pointer */
    (ulpi == 0)				/* null cad pin name pointer */
 ) {
    return(0);
 }
 int rvl; 				/* return code */
 rvl = 1;				/* start return code */
 if(*pnum >= ustc_lib_pin_count) {	/* allocate cad pin check */
    if(ustc_lib_pin_alloc(100) == 0) {
	rvl = 0;			/* allocation error */
    }
    if(rvl == 1) {
	if(*pnum >= ustc_lib_pin_count) { /* check allocation error */
	    rvl = 0;			/* allocation error */
	}
    }
    if(rvl == 0) {
    	ustc_error("Error cad pin allocate\r\n");
	return(0);
    }
 }
 USTC_LIB_PIN * dlpi;			/* destination pin pointer */
 dlpi = ustc_lib_pin + *pnum;		/* set destination pin pointer */
 *dlpi = *ulpi;
 *pnum += 1;				/* next pin number */
 return(1);
}
int ustc_lib_comp_add(u_int32_t *cnum, USTC_LIB_COMP * ulci) /* kicad lib comp add */
{
 if(
    (cnum == 0) ||			/* null comp number pointer */
    (ulci == 0)				/* null cad comp name pointer */
 ) {
    return(0);
 }
 int rvl; 				/* return code */
 rvl = 1;				/* start return code */
 if(*cnum >= ustc_lib_comp_count) {	/* allocate cad comp check */
    if(ustc_lib_comp_alloc(100) == 0) {
	rvl = 0;			/* allocation error */
    }
    if(rvl == 1) {
	if(*cnum >= ustc_lib_comp_count) { /* check allocation error */
	    rvl = 0;			/* allocation error */
	}
    }
    if(rvl == 0) {
    	ustc_error("Error cad comp allocate\r\n");
	return(0);
    }
 }
 USTC_LIB_COMP * dlci;			/* destination comp pointer */
 dlci = ustc_lib_comp + *cnum;		/* set destination comp pointer */
 *dlci = *ulci;
 *cnum += 1;				/* next comp number */
 return(1);
}
int ustc_lib_alias_read(u_int32_t * alnum, u_int8_t * buf, u_int32_t size)
{
 if(
    (alnum == 0) ||			/* alias number pointer check */
    (buf == 0) ||			/* buffer pointer check */
    (size <= 0)				/* buffer size check */
 ) {
    return(0);
 }
 if(*(buf + 0) == '\0') {
    u_int8_t cut;				/* string cuting */
    while(1) {
	if(ustc_read(buf, size, &cut) == 0) {
	    ustc_error("Error read KICAD LIB component alias\r\n");
	    return(0);
	}
	if(*(buf + 0) == '\0') {
	    continue;
	} else {
	    break;
	}
    }
 }
 int pos;				/* buffer position */
 pos = 0;				/* start buffer position */
 if(ustc_cmp(buf,"ALIAS", &pos) == 0) {
    ustc_error("Wait ALIAS, readed {%s}\r\n",
	buf + pos
    );
    return(0);
 }
 while(1) {
    while((*(buf + pos) == ' ') || (*(buf + pos) == '\t')) {
	pos += 1;			/* next buffer position */
    }
    if(*(buf + pos) == '\0') {		/* string terminator check */
	break;				/* loop exit */
    }
    u_int8_t name[128];			/* name buffer */
    u_int8_t cut;			/* name cuting */
    u_int8_t srd;
    cut = 0;				/* clear name cuting */
    srd = 0;				/* readed value */
    if(ustc_str(buf, name, size, &pos, &cut, &srd) == 0) {
        ustc_error("KICAD LIB alias name {%s} read error\r\n", 
	    buf + pos
	);
	return(0);
    } else {
	if(srd == 0) {
    	    ustc_error("Error read KICAD LIB alias name {%s}\r\n", 
		buf
	    );
	    return(0);
	} else {
	    if(ustc_lib_alias_add(
		alnum,			/* alias number pointer */
		name			/* alias name */
	    ) == 0) {
    		ustc_error("KICAD LIB alias {%s} ADD error\r\n", 
		    name		/* alias name */
		);
		return(0);
	    }	
	}
    }
 }
 return(1);
}
int ustc_lib_field_read(u_int8_t * fidx, USTC_LIB_FIELD * ulfi, u_int8_t * buf, u_int32_t size)
{
 if(
    (fidx == 0) ||			/* field number pointer check */
    (ulfi == 0) || 
    (buf == 0) ||			/* buffer pointer check */
    (size <= 0)				/* buffer size check */
 ) {
    return(0);
 }
 if(*(buf + 0) == '\0') {		/* empty buffer check */
    u_int8_t cut;			/* string cuting */
    while(1) {
	if(ustc_read(buf, size, &cut) == 0) {
	    ustc_error("Error read KICAD LIB component field\r\n");
	    return(0);
	}
	if(*(buf + 0) == '\0') {	/* empty buffer check */
	    continue;			/* next file line read */
	} else {
	    break;			/* string readed -> loop exit */
	}
    }
 }
 int rvl;				/* return code */
 rvl = 1; 				/* start return code */
 int pos;				/* buffer position */
 pos = 0;				/* start buffer position */
 if(*(buf + pos) != 'F') {		/* read F header */
    ustc_error("Wait FIELD, readed {%s}\r\n",
	buf + pos
    );
    return(0);
 }
 pos += 1;
 u_int8_t ird;				/* readed */
 int ival;				/* integer value */
 ival = 0;				/* integer value clear */
 ird = 0;				/* readed clear */
 if(ustc_int(buf,&ival,&pos,&ird) == 0) {
    ustc_error("KICAD LIB field x position read error\r\n");
    return(0);
 } else {
    if(ird != 0) {
        *fidx = ival;			/* x coordinate write */
    }
 }
 while(
    (*(buf + pos) == ' ') || 	/* space character test */
    (*(buf + pos) == '\t')		/* tab character test */
 ) {
    pos += 1;			/* next buffer position */
 }
 if((*(buf + pos) == '"')) {
    pos += 1;			/* next buffer position */
 } else {
    ustc_error("Wait KICAD LIB FIELD text separator '\"', readed {%s}\r\n",
        buf + pos
    );
    return(0);
 }
 u_int8_t name[256];			/* name buffer */
 u_int8_t cut;			/* name cuting */
 u_int8_t srd;
 cut = 0;				/* clear name cuting */
 srd = 0;				/* readed clear */
 if(ustc_str(buf, name, size, &pos, &cut, &srd) == 0) {
    ustc_error("Error read KICAD LIB field text {%s}\r\n", 
        buf + pos
    );
    return(0);
 } else {
    if(srd == 0) {
	ustc_error("Error read KICAD LIB field text {%s}\r\n", 
	    buf
        );
        return(0);
    } else {
        int len;			/* string length */
        len = strlen((char *) name); /* string length calculate */
        if(len >= (int)sizeof(name)) { /* check length out of buffer */
    	    len = (int) sizeof(name) - 1; /* last buffer character */
	}
        if(len > 0) {
    	    len -= 1;
	    if(name[len] == '"' ) {
	        name[len] = '\0';
	    }
	}
	len += 1;			/* string length include string terminator */
	ulfi->name = (u_int8_t *) malloc(len); /* buffer allocation */
	if(ulfi->name == 0) {
    	    ustc_error("Error KICAD LIB field text {%s} name allocate\r\n", 
		name		/* text field name */
	    );
	    return(0);
	} else {
	    snprintf(		/* form field name */
	        (char *)ulfi->name, /* field name */
	        len,		/* filed buffer length */
	        "%s",		/* format */
	        name		/* field name */
	    );
	}
    }
 }
 ival = 0;				/* integer value clear */
 ird = 0;				/* readed clear */
 if(ustc_int(buf,&ival,&pos,&ird) == 0) {
    ustc_error("KICAD LIB field x position read error\r\n");
    return(0);
 } else {
    if(ird != 0) {
        ulfi->x0 = ival;		/* x coordinate write */
    }
 }
 ival = 0;				/* integer value clear */
 ird = 0;				/* readed clear */
 if(ustc_int(buf,&ival,&pos,&ird) == 0) {
    ustc_error("KICAD LIB field y position read error\r\n");
    return(0);
 } else {
    if(ird != 0) {
        ulfi->y0 = ival;		/* y coordinate write */
    }
 }
 ival = 0;				/* integer value clear */
 ird = 0;				/* readed clear */
 if(ustc_int(buf,&ival,&pos,&ird) == 0) {
    ustc_error("KICAD LIB field y position read error\r\n");
    return(0);
 } else {
    if(ird != 0) {
        ulfi->height = ival;	/* text height */
    }
 }
 cut = 0;				/* clear name cuting */
 srd = 0;				/* readed clear */
 if(ustc_str(buf, name, size, &pos, &cut, &srd) == 0) {
    ustc_error("Error read KICAD LIB field text orientation {%s}\r\n", 
        buf + pos
    );
    return(0);
 } else {
    if(strcmp((char *)name, "H") == 0) { /* horizontal orientation check */
        ulfi->ornt = USTC_LIB_FIELD_ORNT_HOR; /* orientation write */
    } else
    if(strcmp((char *)name, "V") == 0) { /* vertical orientation check */
        ulfi->ornt = USTC_LIB_FIELD_ORNT_VERT; /* orientation write */
    } else {
        if(rvl == 1) {		/* return code check */
    	    rvl = 0;		/* return code clear */
    	    ustc_error("Unknown KICAD LIB field text orientation {%s}\r\n", 
	        name
	    );
        }
    }
 }
 cut = 0;				/* clear name cuting */
 srd = 0;				/* readed clear */
 if(ustc_str(buf, name, size, &pos, &cut, &srd) == 0) {
    ustc_error("Error read KICAD LIB field text visibility {%s}\r\n", 
        buf + pos
    );
    return(0);
 } else {
    if(strcmp((char *)name, "V") == 0) { /* field visible check */
        ulfi->vis = 1;		/* field visible write  */
    } else
    if(strcmp((char *)name, "I") == 0) { /* field invissible check */
        ulfi->vis = 0;		/* field visible clear */
    } else {
        if(rvl == 1) {		/* return code check */
	    rvl = 0;		/* return code clear */
    	    ustc_error("Unknown KICAD LIB field visibility {%s}\r\n", 
	        name		/* string value */
	    );
        }
    }
 }
 cut = 0;				/* clear name cuting */
 srd = 0;				/* readed clear */
 if(ustc_str(buf, name, size, &pos, &cut, &srd) == 0) {
    ustc_error("Error read KICAD LIB field text horizontal justification {%s}\r\n", 
        buf + pos
    );
    return(0);
 } else {
    if(strcmp((char *)name, "L") == 0) { /* left justification check */
        ulfi->hor = USTC_LIB_FIELD_HOR_L; /* horizontal justify left */
    } else
    if(strcmp((char *)name, "C") == 0) { /* center justification check */
        ulfi->hor = USTC_LIB_FIELD_HOR_C; /* horizontal justify center */
    } else
    if(strcmp((char *)name, "R") == 0) { /* right justification check */
        ulfi->hor = USTC_LIB_FIELD_HOR_R; /* horizontal justify right */
    } else {
        if(rvl == 1) {		/* return code check */
	    rvl = 0;		/* return code clear */
    	    ustc_error("Unknown KICAD LIB field horizontal justify {%s}\r\n", 
	        name
	    );
        }
    }
 }
 cut = 0;				/* clear name cuting */
 srd = 0;				/* readed clear */
 if(ustc_str(buf, name, size, &pos, &cut, &srd) == 0) {
    ustc_error("Error read KICAD LIB field vertical justification {%s}\r\n", 
        buf + pos
    );
    return(0);
 } else {
    if(strcmp((char *)name, "B") == 0) { /* bottom justification check */
        ulfi->vert = USTC_LIB_FIELD_VERT_B; /* vertical justify bottom */
    } else
    if(strcmp((char *)name, "C") == 0) { /* center justification check */
        ulfi->vert = USTC_LIB_FIELD_VERT_C; /* vertical justify center */
    } else
    if(strcmp((char *)name, "T") == 0) { /* top justification check */
        ulfi->vert = USTC_LIB_FIELD_VERT_T; /* vertical justify top */
    } else {
        if(rvl == 1) {
    	    rvl = 0;		/* return code clear */
    	    ustc_error("Unknown KICAD LIB field vertical justify {%s}\r\n", 
	        name		/* vertical justification */	
	    );
        }
    }
 }
 return(1);
}
int ustc_lib_poly_read(u_int32_t * pnum, u_int8_t * buf, u_int32_t size, int * pos)
{
 if(
    (pnum == 0) ||			/* poly number pointer check */
    (pos == 0) ||			/* buffer position check */
    (buf == 0) ||			/* buffer pointer check */
    (size <= 0)				/* buffer size check */
 ) {
    return(0);
 }
 if(*(buf + 0) == '\0') {		/* empty buffer check */
    u_int8_t cut;			/* string cuting */
    while(1) {
	if(ustc_read(buf, size, &cut) == 0) {
	    ustc_error("Error read KICAD LIB component poly point\r\n");
	    return(0);
	}
	if(*(buf + 0) == '\0') {	/* empty buffer check */
	    { continue; } 		/* next file line read */
	} else {
	    { break; }			/* string readed -> loop exit */
	}
    }
 }
 while(1) {
    while(				/* head space loop */
	(*(buf + *pos) == ' ') || 	/* space check */
	(*(buf + *pos) == '\t') ||	/* horizontal tab check */
	(*(buf + *pos) == '\v')		/* vertical tab check */
    ) {
	*pos = *pos + 1;		/* next buffer position */
    }
    if(*(buf + *pos) == '\0') {		/* string terminator check */
	{ break; } 			/* loop exit */
    }
    u_int32_t svpos;
    svpos = *pos;
    if(
	(ustc_cmp(buf, "DC", pos) > 0) || /* polygon filled */
	(ustc_cmp(buf, "F", pos) > 0) || /* polygon filled */
	(ustc_cmp(buf, "Y", pos) > 0) || /* polygon filled */
	(ustc_cmp(buf, "N", pos) > 0)	/* polygon not filled */
    ) {
        *pos = svpos;
	{ break; }
    }
    u_int8_t ird;			/* readed */
    int ival;				/* integer value */
    ival = 0;				/* integer value clear */
    ird = 0;				/* readed clear */
    int32_t x0;
    if(ustc_int(buf,&ival,pos,&ird) == 0) {
	ustc_error("KICAD LIB poly x position read error\r\n");
	return(0);
    } else {
	if(ird != 0) {
    	    x0 = ival;			/* x coordinate write */
	} else {
	    ustc_error("KICAD LIB poly x position read error\r\n");
	    return(0);
	}
    }
    ival = 0;				/* integer value clear */
    ird = 0;				/* readed clear */
    int32_t y0;
    if(ustc_int(buf,&ival,pos,&ird) == 0) {
	ustc_error("KICAD LIB poly y position read error\r\n");
	return(0);
    } else {
	if(ird != 0) {
    	    y0 = ival;			/* x coordinate write */
	} else {
	    ustc_error("KICAD LIB poly y position read error\r\n");
	    return(0);
	}
    }
    if(ustc_lib_poly_add(
	pnum,				/* poly number pointer */
	x0,				/* poly x position */
	y0				/* poly y position */
    ) == 0) {
	ustc_error("KICAD LIB poly add error\r\n");
	return(0);
    }
 }
 return(1);
}
int ustc_lib_draw_read(u_int32_t * dnum, u_int32_t * pnum, u_int32_t * rnum,
u_int32_t * rngnum, u_int32_t * anum, u_int32_t * tnum, u_int8_t * buf, u_int32_t size)
{
 if(
    (dnum == 0) ||			/* draw number pointer check */
    (pnum == 0) ||			/* poly number pointer check */
    (rnum == 0) ||			/* rectangle number pointer check */
    (rngnum == 0) ||			/* ring number pointer check */
    (anum == 0) ||			/* arc number pointer check */
    (tnum == 0) ||			/* text number pointer check */
    (buf == 0) ||			/* buffer pointer check */
    (size <= 0)				/* buffer size check */
 ) {
    return(0);
 }
 int rvl;				/* return code */
 rvl = 1; 				/* start return code */
 while(1) {
    if(*(buf + 0) == '\0') {		/* empty buffer check */
	u_int8_t cut;			/* string cuting */
	cut = 0;			/* catting clear */ 
	while(1) {
	    if(ustc_read(buf, size, &cut) == 0) {
		ustc_error("KICAD LIB component draw element read error\r\n");
		return(0);
	    }
	    if(*(buf + 0) == '\0') {	/* empty buffer check */
		{ continue; }		/* next file line read */
	    } else {
		{ break; }		/* string readed -> loop exit */
	    }
	}
    }
    USTC_LIB_DRAW uldi;			/* kicad lib draw item */
    if(ustc_lib_draw_clear(&uldi) == 0) { /* kicad lib draw clear */
	ustc_error("KICAD LIB draw element clear error\r\n");
	return(0);
    }
    int pos;				/* buffer position */
    pos = 0;				/* start buffer position */
    if(ustc_cmp(buf,"X", &pos) > 0) {	/* pin check */
	return(1);
    } else
    if(ustc_cmp(buf,"ENDDRAW", &pos) > 0) {	/* endraw check */
	return(1);			/* draw read termination */
    } else
    if(ustc_cmp(buf,"P", &pos) > 0) {	/* poly line check */
	u_int32_t count;
	u_int8_t ird;			/* readed */
	int ival;			/* integer value */
        ival = 0;			/* integer value clear */
	ird = 0;			/* readed clear */
	if(ustc_int(buf,&ival,&pos,&ird) == 0) {
	    ustc_error("KICAD LIB poly count read error\r\n");
	    return(0);
	} else {
	    if(ird != 0) {
    		count = ival;		/* count write */
	    } else {
		count = 0;		/* count clear */
	    }
	}
	if(ustc_lib_poly_add(		/* kicad lib poly item add */
	    pnum,			/* poly number */
	    count,			/* points count */
	    0				/* empty filled flag */
	) == 0) {
	    ustc_error("KICAD LIB poly add error\r\n");
	    return(0);
	    
	}
	USTC_LIB_POLY * ulpfi;		/* poly line header */
	ulpfi = ustc_lib_poly + (*pnum - 1); /* poly header pointer */
	uldi.type = USTC_LIB_DRAW_POLY;	/* draw type poly */ 
        ival = 0;			/* integer value clear */
	ird = 0;			/* readed clear */
	if(ustc_int(buf,&ival,&pos,&ird) == 0) {
	    ustc_error("KICAD LIB poly common in all parts read error\r\n");
	    return(0);
	} else {
	    if(ird != 0) {
    		uldi.unit = ival;	/* unit number */
	    } else {
    		uldi.unit = 0;		/* unit not readed  */
	    }
	}
        ival = 0;			/* integer value clear */
	ird = 0;			/* readed clear */
	if(ustc_int(buf,&ival,&pos,&ird) == 0) {
	    ustc_error("KICAD LIB poly parts common in all representation read error\r\n");
	    return(0);
	} else {
	    if(ird != 0) {
    		uldi.convert = ival;	/* 0 - common in 2 representations, else 1 or 2 */
	    } else {
    		uldi.convert = 0;	/* parameter not readed */
	    }
	}
        ival = 0;			/* integer value clear */
	ird = 0;			/* readed clear */
	if(ustc_int(buf,&ival,&pos,&ird) == 0) {
	    ustc_error("KICAD LIB poly width read error\r\n");
	    return(0);
	} else {
	    if(ird != 0) {
    		uldi.width = ival;	/*  kicad lib line width */
	    } else {
    		uldi.width = 0;		/* kicad lib line width not readed */
	    }
	}
	u_int32_t pstart;		/* point start point */
	pstart = *pnum;			/* point start read */
	uldi.ref = (*pnum - 1);		/* point reference write */
	if(ustc_lib_poly_read(		/* poly read */
	    pnum, 			/* point number pointer */
	    buf,			/* buffer */
	    size,			/* buffer size */
	    &pos
	) == 0) {
	    ustc_error("KICAD LIB poly read error\r\n");
	    return(0);
	}
	if(ustc_cmp(buf,"N", &pos) > 0) {  /* filling flag check */
	    ulpfi->y0 = USTC_LIB_POLY_FILL_NO; /* poly filling write */
	} else
	if(ustc_cmp(buf,"DC", &pos) > 0) {  /* filling flag check */
	    ulpfi->y0 = USTC_LIB_POLY_FILL_DC;
	} else
	if(ustc_cmp(buf,"F", &pos) > 0) { /* polygon filling check */
	    ulpfi->y0 = USTC_LIB_POLY_FILL_FILL;
	} else
	if(ustc_cmp(buf,"Y", &pos) > 0) { /* polygon filling check */
	    ulpfi->y0 = USTC_LIB_POLY_FILL_YES;
	} else {
	    ulpfi->y0 = USTC_LIB_POLY_FILL_UNKNOWN;
	}
	u_int32_t rcount;		/* points read count */
	rcount = (*pnum - pstart);	/* points count calculate */
	if(rcount != count) {
	    ustc_error("KICAD LIB poly read error, point count {%d}, points in poly header {%d}\r\n",
		rcount,			/* points readed */
		count			/* points in header */
	    );
	    return(0);
	} else {
	    ulpfi->x0 = rcount;
	}
    } else
    if(ustc_cmp(buf,"S", &pos) > 0) {	/* rectangle header check */
	USTC_LIB_RECT ulri;		/* kicad lib rectangle */
	if(ustc_lib_rect_clear(&ulri) == 0) { /* kicad lib rectangle clear */
	    ustc_error("KICAD LIB rect clear error\r\n");
	    return(0);
	}
	u_int8_t ird;
	int ival;			/* integer value */
        ival = 0;			/* integer value clear */
	ird = 0;			/* readed clear */
	if(ustc_int(buf,&ival,&pos,&ird) == 0) {
	    ustc_error("KICAD LIB rect x0 read error\r\n");
	    return(0);
	} else {
	    if(ird != 0) {
    		ulri.x0 = ival;		/* x0 coordinate write */
	    } else {
    		ulri.x0 = 0;		/* x0 coordinate clear */
	    }
	}
	ird = 0;			/* readed clear */
	if(ustc_int(buf,&ival,&pos,&ird) == 0) {
	    ustc_error("KICAD LIB rect y0 read error\r\n");
	    return(0);
	} else {
	    if(ird != 0) {
    		ulri.y0 = ival;		/* y0 coordinate write */
	    } else {
    		ulri.y0 = 0;		/* y0 coordinate clear */
	    }
	}
	ird = 0;			/* readed clear */
	if(ustc_int(buf,&ival,&pos,&ird) == 0) {
	    ustc_error("KICAD LIB rect x1 read error\r\n");
	    return(0);
	} else {
	    if(ird != 0) {
    		ulri.x1 = ival;		/* x1 coordinate write */
	    } else {
    		ulri.x1 = 0;		/* x1 coordinate clear */
	    }
	}
	ird = 0;			/* readed clear */
	if(ustc_int(buf,&ival,&pos,&ird) == 0) {
	    ustc_error("KICAD LIB rect y1 read error\r\n");
	    return(0);
	} else {
	    if(ird != 0) {
    		ulri.y1 = ival;		/* y1 coordinate write */
	    } else {
    		ulri.y1 = 0;		/* y1 coordinate clear */
	    }
	}
	uldi.ref = *rnum; 		/* draw rectangle reference write */
	uldi.type = USTC_LIB_DRAW_RECT;	/* poly */ 
        ival = 0;			/* integer value clear */
	ird = 0;			/* readed clear */
	if(ustc_int(buf,&ival,&pos,&ird) == 0) {
	    ustc_error("KICAD LIB rect common in all parts read error\r\n");
	    return(0);
	} else {
	    if(ird != 0) {
    		uldi.unit = ival;	/* unit number */
	    } else {
    		uldi.unit = 0;		/* unit number clear */
	    }
	}
        ival = 0;			/* integer value clear */
	ird = 0;			/* readed clear */
	if(ustc_int(buf,&ival,&pos,&ird) == 0) {
	    ustc_error("KICAD LIB poly common in all representation read error\r\n");
	    return(0);
	} else {
	    if(ird != 0) {
    		uldi.convert = ival;	/* 0 - common in 2 representations, else 1 or 2 */
	    } else {	
    		uldi.convert = 0;	/* convert number clear */
	    }
	}
        ival = 0;			/* integer value clear */
	ird = 0;			/* readed clear */
	if(ustc_int(buf,&ival,&pos,&ird) == 0) {
	    ustc_error("KICAD LIB rect width read error\r\n");
	    return(0);
	} else {
	    if(ird != 0) {
    		uldi.width = ival;	/* line width */
	    } else {
    		uldi.width = 0;		/* kicad lib recttangle width clear error */
	    }
	}
	u_int8_t name[32];		/* filling buffer */
	u_int8_t cut;			/* name cuting */
	u_int8_t srd;
	cut = 0;			/* clear name cuting */
	srd = 0;			/* readed value */
	if(ustc_str(buf, name, size, &pos, &cut, &srd) == 0) {
    	    ustc_error("Error read KICAD rect filling {%s}\r\n", 
		buf + pos
	    );
	    return(0);
	} else {
	    if(srd > 0) {		/* string readed check */
		if(name[0] == 'F') {	/* filling character check */
		    ulri.fill = 1;	/* filling set */
		} else
		if(name[0] == 'N') {	/* normal filling check */
		    ulri.fill = 0;	/* filling clear */
		} else {
		    ulri.fill = name[0]; /* fillig character write */
		}
	    } else {
		ulri.fill = 0;
	    }
	}
	if(ustc_lib_rect_add(		/* rectangle add */
	    rnum,			/* rectangle number */
	    &ulri			/* kicad lib rectangle */
	) == 0) {
	    ustc_error("KICAD LIB rect add error\r\n");
	    return(0);
	}
    } else
    if(ustc_cmp(buf,"C", &pos) > 0) {	/* kicad lib ring test */
	USTC_LIB_RING ulri;		/* kicad lib ring */
	if(ustc_lib_ring_clear(&ulri) == 0) { /* kicad lib ring clear information */
	    ustc_error("KICAD LIB ring clear error\r\n");
	    return(0);
	}
	u_int8_t ird;
	int ival;			/* integer value */
        ival = 0;			/* integer value clear */
	ird = 0;			/* readed clear */
	if(ustc_int(buf,&ival,&pos,&ird) == 0) {
	    ustc_error("KICAD LIB ring x0 position read error\r\n");
	    return(0);
	} else {
	    if(ird != 0) {
    		ulri.x0 = ival;		/* x0 coordinate write */
	    } else {
    		ulri.x0 = 0;		/* 0 coordinate write */
	    }
	}
	ird = 0;			/* readed clear */
	if(ustc_int(buf,&ival,&pos,&ird) == 0) {
	    ustc_error("KICAD LIB ring y0 position read error\r\n");
	    return(0);
	} else {
	    if(ird != 0) {
    		ulri.y0 = ival;		/* y0 coordinate write */
	    } else {
    		ulri.y0 = 0;		/* y0 coordinate clear */
	    }
	}
	ird = 0;			/* readed clear */
	if(ustc_int(buf,&ival,&pos,&ird) == 0) {
	    ustc_error("KICAD LIB ring radius read error\r\n");
	    return(0);
	} else {
	    if(ird != 0) {
    		ulri.rad = ival;	/* cad ring radius write */
	    } else {
    		ulri.rad = 0;		/* cad ring radius clear */
	    }
	}
	uldi.ref = *rngnum; 		/* ring reference write */
	uldi.type = USTC_LIB_DRAW_RING;	/* ring */ 
        ival = 0;			/* integer value clear */
	ird = 0;			/* readed clear */
	if(ustc_int(buf,&ival,&pos,&ird) == 0) {
	    ustc_error("KICAD LIB poly common in all parts read error\r\n");
	    return(0);
	} else {
	    if(ird != 0) {
    		uldi.unit = ival;	/* unit number write */
	    } else {
    		uldi.unit = 0;		/* unit number clear */
	    }
	}
        ival = 0;			/* integer value clear */
	ird = 0;			/* readed clear */
	if(ustc_int(buf,&ival,&pos,&ird) == 0) {
	    ustc_error("KICAD LIB ring common in all representation read error\r\n");
	    return(0);
	} else {
	    if(ird != 0) {
    		uldi.convert = ival;	/* 0 - common in 2 representations, else 1 or 2 */
	    } else {
    		uldi.convert = 0;	/* conver clear */
	    }
	}
        ival = 0;			/* integer value clear */
	ird = 0;			/* readed clear */
	if(ustc_int(buf,&ival,&pos,&ird) == 0) {
	    ustc_error("KICAD LIB ring width read error\r\n");
	    return(0);
	} else {
	    if(ird != 0) {
    		uldi.width = ival;	/* line width write */
	    } else {
    		uldi.width = 0;		/* line width clear */
	    }
	}
    	if(ustc_cmp(buf,"N", &pos) > 0) {
	    ulri.fill = USTC_LIB_RING_FILL_NO;
	} else
    	if(ustc_cmp(buf,"F", &pos) > 0) {
	    ulri.fill = USTC_LIB_RING_FILL_FILL;
	} else
    	if(ustc_cmp(buf,"Y", &pos) > 0) {
	    ulri.fill = USTC_LIB_RING_FILL_YES;
	} else {
	    ulri.fill = USTC_LIB_RING_FILL_UNKNOWN;
	}
	if(ustc_lib_ring_add(		/* kicad lib ring add */
	    rngnum,			/* ring number pointer */
	    &ulri			/* kicad lib ring */
	) == 0) {
	    ustc_error("KICAD LIB ring add error\r\n");
	    return(0);
	}
    } else
    if(
	(ustc_cmp(buf,"To", &pos) > 0) || /* arc header check */
	(ustc_cmp(buf,"A", &pos) > 0)	/* arc extended header check */
    ) {
	USTC_LIB_ARC ulai;		/* kicad lib arc */
	if(ustc_lib_arc_clear(&ulai) == 0) { /* kicad lib arc clear */
	    ustc_error("KICAD LIB arc clear error\r\n");
	    return(0);
	}
	u_int8_t ird;
	int ival;			/* integer value */
        ival = 0;			/* integer value clear */
	ird = 0;			/* readed clear */
	if(ustc_int(buf,&ival,&pos,&ird) == 0) {
	    ustc_error("KICAD LIB arc x0 position read error\r\n");
	    return(0);
	} else {
	    if(ird != 0) {
    		ulai.x0 = ival;		/* x0 coordinate write */
	    } else {
    		ulai.x0 = 0;		/* x0 coordinate clear */
	    }
	}
	ird = 0;			/* readed clear */
	if(ustc_int(buf,&ival,&pos,&ird) == 0) {
	    ustc_error("KICAD LIB arc y0 position read error\r\n");
	    return(0);
	} else {
	    if(ird != 0) {
    		ulai.y0 = ival;		/* y0 coordinate write */
	    } else {
    		ulai.y0 = 0;		/* y0 coordinate clear */
	    }
	}
	ird = 0;			/* readed clear */
	if(ustc_int(buf,&ival,&pos,&ird) == 0) {
	    ustc_error("KICAD LIB arc radius read error\r\n");
	    return(0);
	} else {
	    if(ird != 0) {
    		ulai.rad = ival;	/*  kicad lib arc radus write */
	    } else {
    		ulai.rad = 0;		/* kicad lib radius clear */
	    }
	}
	ird = 0;			/* readed clear */
	if(ustc_int(buf,&ival,&pos,&ird) == 0) {
	    ustc_error("KICAD LIB arc start engle read error\r\n");
	    return(0);
	} else {
	    if(ird != 0) {
    		ulai.start = ival;	/* kicad lib start angle write */
	    } else {
    		ulai.start = 0;		/* kicad lib start angle clear */
	    }
	}
	ird = 0;			/* readed clear */
	if(ustc_int(buf,&ival,&pos,&ird) == 0) {
	    ustc_error("KICAD LIB arc end angle read error\r\n");
	    return(0);
	} else {
	    if(ird != 0) {
    		ulai.end = ival;	/* kicad lib end angle write */
	    } else {
    		ulai.end = 0;		/* kicad lib arc end angle clear */
	    }
	}
	uldi.ref = *anum; 		/* draw reference write */
	uldi.type = USTC_LIB_DRAW_ARC;	/* arc reference */ 
        ival = 0;			/* integer value clear */
	ird = 0;			/* readed clear */
	if(ustc_int(buf,&ival,&pos,&ird) == 0) {
	    ustc_error("KICAD LIB arc common in all parts read error\r\n");
	    return(0);
	} else {
	    if(ird != 0) {
    		uldi.unit = ival;	/* kicad lib unit write */
	    } else {
    		uldi.unit = 0;		/* kicad lib unit clear */
	    }
	}
        ival = 0;			/* integer value clear */
	ird = 0;			/* readed clear */
	if(ustc_int(buf,&ival,&pos,&ird) == 0) {
	    ustc_error("KICAD LIB poly common in all representation read error\r\n");
	    return(0);
	} else {
	    if(ird != 0) {
    		uldi.convert = ival;	/* 0 - common in 2 representations, else 1 or 2 */
	    } else {
    		uldi.convert = 0;	/* cad convert clear error */
	    }
	}
        ival = 0;			/* integer value clear */
	ird = 0;			/* readed clear */
	if(ustc_int(buf,&ival,&pos,&ird) == 0) {
	    ustc_error("KICAD LIB arc width read error\r\n");
	    return(0);
	} else {
	    if(ird != 0) {
    		uldi.width = ival;	/* line width */
	    } else {
    		uldi.width = 0;
	    }
	}
	if(ustc_cmp(buf,"Y", &pos) > 0) { /* filling yes check */
	    ulai.fill = USTC_LIB_ARC_FILL_FILL; /* filling */
	} else {
	    if(ustc_cmp(buf,"N", &pos) > 0) { /* filling no */
    		ulai.fill = USTC_LIB_ARC_FILL_NO;
	    } else {
    		ulai.fill = USTC_LIB_ARC_FILL_UNKNOWN;
	    }
	}
        ival = 0;			/* integer value clear */
	ird = 0;			/* readed clear */
	if(ustc_int(buf,&ival,&pos,&ird) == 0) {
	    ustc_error("KICAD LIB arc x start read error\r\n");
	    return(0);
	} else {
	    if(ird != 0) {
    		ulai.xs = ival;		/* kicad lib arc x start write */
	    } else {
    		ulai.xs = 0;		/* kicad lib arc x start clear */
	    }
	}
        ival = 0;			/* integer value clear */
	ird = 0;			/* readed clear */
	if(ustc_int(buf,&ival,&pos,&ird) == 0) {
	    ustc_error("KICAD LIB arc y start read error\r\n");
	    return(0);
	} else {
	    if(ird != 0) {
    		ulai.ys = ival;		/* kicad lib arc y start write */
	    } else {
    		ulai.ys = 0;		/* kicad lib arc y start clear */
	    }
	}
        ival = 0;			/* integer value clear */
	ird = 0;			/* readed clear */
	if(ustc_int(buf,&ival,&pos,&ird) == 0) {
	    ustc_error("KICAD LIB arc x end read error\r\n");
	    return(0);
	} else {
	    if(ird != 0) {
    		ulai.xe = ival;
	    } else {
    		ulai.xe = 0;
	    }
	}
        ival = 0;			/* integer value clear */
	ird = 0;			/* readed clear */
	if(ustc_int(buf,&ival,&pos,&ird) == 0) {
	    ustc_error("KICAD LIB arc y end read error\r\n");
	    return(0);
	} else {
	    if(ird != 0) {
    		ulai.ye = ival;		/* kicad lib y end write */ 
	    } else {
    		ulai.ye = 0;		/* kicad lib y end clear */
	    }
	}
	if(ustc_lib_arc_add(
	    anum,			/* arc number pointer */
	    &ulai			/* kicad lib arc information */
	) == 0) {
	    ustc_error("KICAD LIB arc add error\r\n");
	    return(0);
	}
    } else
    if(ustc_cmp(buf,"T", &pos) > 0) {
	USTC_LIB_TEXT ulti;		/* kicad lib text */
	if(ustc_lib_text_clear(&ulti) == 0) { /* kicad lib text clear */
	    ustc_error("CAD LIB text clear error\r\n");
	    return(0);
	}
	u_int8_t ird;
	int ival;			/* integer value */
        ival = 0;			/* integer value clear */
	ird = 0;			/* readed clear */
	if(ustc_int(buf,&ival,&pos,&ird) == 0) {
	    ustc_error("KICAD LIB text orientation\r\n");
	    return(0);
	} else {
	    if(ird != 0) {
    		ulti.ornt = ival;	/* x coordinate write */
	    } else {
    		ulti.ornt = 0;
	    }
	}
	ird = 0;			/* readed clear */
	if(ustc_int(buf,&ival,&pos,&ird) == 0) {
	    ustc_error("KICAD LIB text x0 position\r\n");
	    return(0);
	} else {
	    if(ird != 0) {
    		ulti.x0 = ival;		/* x coordinate write */
	    } else {
    		ulti.x0 = 0;
	    }
	}
	ird = 0;			/* readed clear */
	if(ustc_int(buf,&ival,&pos,&ird) == 0) {
	    ustc_error("KICAD LIB text y0 position\r\n");
	    return(0);
	} else {
	    if(ird != 0) {
    		ulti.y0 = ival;		/* x coordinate write */
	    } else {
    		ulti.y0 = 0;
	    }
	}
	ird = 0;			/* readed clear */
	if(ustc_int(buf,&ival,&pos,&ird) == 0) {
	    ustc_error("KICAD LIB text height\r\n");
	    return(0);
	} else {
	    if(ird != 0) {
    		ulti.height = ival;		/* x coordinate write */
	    } else {
    		ulti.height = 0;
	    }
	}
	uldi.ref = *tnum; 		/* draw reference */
	uldi.type = USTC_LIB_DRAW_TEXT;	/* text type */ 
        ival = 0;			/* integer value clear */
	ird = 0;			/* readed clear */
	if(ustc_int(buf,&ival,&pos,&ird) == 0) {
	    ustc_error("KICAD LIB poly parts common in alls read error\r\n");
	    return(0);
	} else {
	    if(ird != 0) {
    		uldi.unit = ival;
	    } else {
    		uldi.unit = 0;
	    }
	}
        ival = 0;			/* integer value clear */
	ird = 0;			/* readed clear */
	if(ustc_int(buf,&ival,&pos,&ird) == 0) {
	    ustc_error("KICAD LIB poly parts common in alls read error\r\n");
	    return(0);
	} else {
	    if(ird != 0) {
    		uldi.convert = ival;	/* 0 - common in 2 representations, else 1 or 2 */
	    } else {
    		uldi.convert = 0;
	    }
	}
	if(ustc_cmp(buf,"1", &pos) > 0) { /* one present check */
	    ulti.unused = 1; 		/* one present set */	
	} else {
	    ulti.unused = 255; 		/* one present set */	
	}
	u_int8_t name[128];		/* name buffer */
	u_int8_t cut;			/* name cuting */
	u_int8_t srd;
	cut = 0;			/* clear name cuting */
	srd = 0;			/* readed value */
	if(ustc_str(buf, name, size, &pos, &cut, &srd) == 0) {
	    if(rvl == 1) {
    	        ustc_error("Error read KICAD LIB text {%s}\r\n", 
		    buf + pos
		);
		rvl = 0;
	    }
	    if(ulti.unused == 1) {
		snprintf(
		    (char *) name,
		    sizeof(name),
		    "1"
		);
	    } else {
		name[0] = '\0';
	    }
	} else {
	    if(srd == 0) {
    		ustc_error("Error read KICAD LIB text {%s}\r\n", 
		    buf
		);
		return(0);
	    } else {
		int len;
		len = strlen((char *) name) + 1;
		ulti.text = (u_int8_t *) malloc(len);
		if(ulti.text == 0) {
    		    ustc_error("KICAD LIB text name {%s} allocation error\r\n", 
			name		/* text name */	
		    );
		    return(0);
		} else {
		    snprintf(
			(char *) ulti.text, /* text buffer */
			len,		/* buffer length */
			"%s",		/* format */
			name		/* text name */
		    );
		}
	    }
	}
	if(ustc_lib_text_add(
	    tnum,			/* text number pointer */
	    &ulti			/* text information */
	) == 0) {
	    ustc_error("KICAD LIB text add error\r\n");
	    return(0);
	}
    } else {
	ustc_error(
	    "KICAD LIB draw element unknown type, wait "
	    "P or S or C or To or T or X or ENDRAW, readed {%s}\r\n",
	    buf + pos
	);
	return(0);
    }
    if(ustc_lib_draw_add(
	dnum, 				/* draw number pointer */
	&uldi				/* draw information */
    ) == 0) {
	ustc_error("KICAD LIB draw add error\r\n");
	return(0);
    }
    *(buf + 0) = '\0';			/* read next file line */
 }
 return(1);
}
int ustc_lib_pin_read(u_int32_t * pnum, u_int8_t * buf, u_int32_t size) /* pin read */
{
 if(
    (pnum == 0) ||			/* poly number pointer check */
    (buf == 0) ||			/* buffer pointer check */
    (size <= 0)				/* buffer size check */
 ) {
    return(0);
 }
 int rvl;				/* return code */
 rvl = 1; 				/* start return code */
 while(1) {
    if(*(buf + 0) == '\0') {		/* empty buffer check */
	u_int8_t cut;			/* string cuting */
	cut = 0;			/* catting clear */ 
	while(1) {
	    if(ustc_read(buf, size, &cut) == 0) {
		ustc_error("KICAD LIB component pin element read error\r\n");
		return(0);
	    }
	    if(*(buf + 0) == '\0') {	/* empty buffer check */
		{ continue; }		/* next file line read */
	    } else {
		{ break; }		/* string readed -> loop exit */
	    }
	}
    }
    USTC_LIB_PIN ulpi;			/* cad lib pin item */
    if(ustc_lib_pin_clear(&ulpi) == 0) { /* cad lib pin clear */
	ustc_error("KICAD LIB pin element clear error\r\n");
	return(0);
    }
    int pos;				/* buffer position */
    pos = 0;				/* start buffer position */
    if(ustc_cmp(buf,"ENDDRAW", &pos) != 0) {	/* enpin check */
	return(1);			/* pin read termination */
    } else
    if(ustc_cmp(buf,"X", &pos) > 0) {
	USTC_LIB_PIN ulpi;		/* kicad lib pin */
	if(ustc_lib_pin_clear(&ulpi) == 0) { /* kicad lib pin clear */
	    ustc_error("KICAD LIB pin clear error\r\n");
	    return(0);
	}
	u_int8_t name[128];		/* name buffer */
	u_int8_t cut;			/* name cuting */
	u_int8_t srd;			/* string readed */
	cut = 0;			/* clear name cuting */
	srd = 0;			/* readed value */
	if(ustc_str(buf, name, size, &pos, &cut, &srd) == 0) {
    	    ustc_error("Error read KICAD LIB pin name {%s}\r\n", 
		buf + pos
	    );
	    return(0);
	} else {
	    if(srd == 0) {
    		ustc_error("Error read KICAD LIB pin {%s} name\r\n", 
		    buf
		);
		return(0);
	    } else {
		int len;		/* name length */
		len = strlen((char *) name) + 1; /* name length calculate */
		ulpi.name = (u_int8_t *) malloc(len); /* cad pin name allocate */
		if(ulpi.name == 0) {	/* name allocation check */
    		    ustc_error("KICAD LIB pin name {%s} allocation error\r\n", 
			name		/* pin name */	
		    );
		    return(0);
		} else {
		    snprintf(		/* pin name form */
			(char *) ulpi.name, /* pin buffer */
			len,		/* buffer length */
			"%s",		/* format */
			name		/* pin name */
		    );
		}
	    }
	}
	u_int8_t ird;			/* readed value */
	int ival;			/* integer value */
        ival = 0;			/* integer value clear */
	ird = 0;			/* readed clear */
	if(ustc_int(buf,&ival,&pos,&ird) == 0) {
	    ustc_error("KICAD LIB pin number read error\r\n");
	    return(0);
	} else {
	    if(ird != 0) {
    		ulpi.num = ival;	/* kicad lib pin number write */
	    } else {
    		ulpi.num = 0;
	    }
	}
	ird = 0;			/* readed clear */
	if(ustc_int(buf,&ival,&pos,&ird) == 0) {
	    ustc_error("KICAD LIB pin x0 position read\r\n");
	    return(0);
	} else {
	    if(ird != 0) {
    		ulpi.x0 = ival;		/* x coordinate write */
	    } else {
    		ulpi.x0 = 0;		/* x coordinate clear */
	    }
	}
	ird = 0;			/* readed clear */
	if(ustc_int(buf,&ival,&pos,&ird) == 0) {
	    ustc_error("KICAD LIB pin y0 position read\r\n");
	    return(0);
	} else {
	    if(ird != 0) {
    		ulpi.y0 = ival;		/* x coordinate write */
	    } else {
    		ulpi.y0 = 0;		/* y coordinate clear */
	    }
	}
	ird = 0;			/* readed clear */
	if(ustc_int(buf,&ival,&pos,&ird) == 0) {
	    ustc_error("KICAD LIB pin length read error\r\n");
	    return(0);
	} else {
	    if(ird != 0) {
    		ulpi.length = ival;	/* pin length write */
	    } else {
    		ulpi.length = 0;	/* pin length clear */
	    }
	}
	cut = 0;			/* clear name cuting */
	srd = 0;			/* readed value */
	if(ustc_str(buf, name, size, &pos, &cut, &srd) == 0) {
    	    ustc_error("Error read KICAD LIB pin orientation {%s}\r\n", 
		buf + pos
	    );
	    return(0);
	} else {
	    if(srd == 0) {
    		ustc_error("Error read KICAD LIB pin {%s} orientation\r\n", 
		    buf
		);
		return(0);
	    } else {
		if(strcmp((char *)name,"U") == 0) { /* orientation up string check */
		    ulpi.ornt = USTC_LIB_PIN_ORNT_UP;	/* orientation up write */
		} else
		if(strcmp((char *)name,"D") == 0) { /* orientation down check*/	
		    ulpi.ornt = USTC_LIB_PIN_ORNT_DOWN; /* orientation down write */
		} else
		if(strcmp((char *)name,"R") == 0) { /* orientation right check */
		    ulpi.ornt = USTC_LIB_PIN_ORNT_RIGHT; /* orientation right write */
		} else
		if(strcmp((char *)name,"L") == 0) { /* orientation left check */
		    ulpi.ornt = USTC_LIB_PIN_ORNT_LEFT; /* orientation left write */
		} else {
		    ulpi.ornt = USTC_LIB_PIN_ORNT_LEFT; /* orientation left */
		}
	    }
	}
        ival = 0;			/* integer value clear */
	ird = 0;			/* readed clear */
	if(ustc_int(buf,&ival,&pos,&ird) == 0) {
	    ustc_error("KICAD LIB pin number height read error\r\n");
	    return(0);
	} else {
	    if(ird != 0) {
    		ulpi.numheight = ival;
	    } else {
    		ulpi.numheight = 0;
	    }
	}
        ival = 0;			/* integer value clear */
	ird = 0;			/* readed clear */
	if(ustc_int(buf,&ival,&pos,&ird) == 0) {
	    ustc_error("KICAD LIB pin name height read error\r\n");
	    return(0);
	} else {
	    if(ird != 0) {
    		ulpi.nameheight = ival;
	    } else {
    		ulpi.nameheight = 0;
	    }
	}
        ival = 0;			/* integer value clear */
	ird = 0;			/* readed clear */
	if(ustc_int(buf,&ival,&pos,&ird) == 0) {
	    ustc_error("KICAD LIB poly parts common in alls read error\r\n");
	    return(0);
	} else {
	    if(ird != 0) {
    		ulpi.unit = ival;	/* 0 - common in all parts, else part number */
	    } else {
    		ulpi.unit = 0;		/* unit number clear */
	    }
	}
        ival = 0;			/* integer value clear */
	ird = 0;			/* readed clear */
	if(ustc_int(buf,&ival,&pos,&ird) == 0) {
	    ustc_error("KICAD LIB poly parts common in alls read error\r\n");
	    return(0);
	} else {
	    if(ird != 0) {
    		ulpi.convert = ival;	/* 0 - common in 2 representations, else 1 or 2 */
	    } else {
    		ulpi.convert = 0;	/* conver number clear */
	    }
	}
	cut = 0;			/* clear name cuting */
	srd = 0;			/* readed value */
	if(ustc_str(buf, name, size, &pos, &cut, &srd) == 0) {
    	    ustc_error("Error read KICAD LIB pin etype {%s}\r\n", 
		buf + pos
	    );
	    return(0);
	} else {
	    if(srd > 0) {
		ulpi.etype = name[0];
	    } else {
		ulpi.etype = 0;
	    }
	}
	cut = 0;			/* clear name cuting */
	srd = 0;			/* readed value */
	if(ustc_str(buf, name, size, &pos, &cut, &srd) == 0) {
    	    ustc_error("Error read KICAD LIB pin shape {%s}\r\n", 
		buf + pos
	    );
	    return(0);
	} else {
	    if(srd > 0) {
		if(name[0] == 0) {
		    ulpi.shape = 0;
		} else {
		    ulpi.shape = name[0] | (((u_int16_t) name[1]) << 8);
		}
	    } else {
		ulpi.shape = 0;
	    }
	}
	if(ustc_lib_pin_add(
	    pnum, 			/* pin number pointer */
	    &ulpi			/* pin information */
        ) == 0) {
    	    ustc_error("KICAD LIB pin add error\r\n");
	    return(0);
	}
	*(buf + 0) = '\0';		/* read next file line */
    } else {
	ustc_error(
	    "Wait KICAD LIB pin, X or ENDRAW, readed {%s}\r\n",
	    buf + pos
	);
	return(0);
    }
 }
 return(1);
}
int ustc_lib_comp_read( u_int32_t * cnum, u_int32_t * alnum,
u_int32_t * flnum, u_int32_t * drnum, u_int32_t * plnum, u_int32_t * rcnum,
u_int32_t * rngnum, u_int32_t * arnum, u_int32_t * txnum, u_int32_t * pnnum, 
u_int8_t * buf, u_int32_t size)
{
 if(
    (cnum == 0) ||			/* component number pointer check */
    (alnum == 0) ||			/* alias number pointer check */
    (flnum == 0) ||			/* field number pointer check */
    (drnum == 0) ||			/* draw number pointer check */
    (plnum == 0) ||			/* poly number pointer */
    (rcnum == 0) ||			/* rectangle number pointer */
    (rngnum == 0) ||			/* ring number pointer */
    (arnum == 0) ||			/* arc number pointer */
    (txnum == 0) ||			/* text number pointer */
    (pnnum == 0) ||			/* pin number pointer */
    (buf == 0) ||			/* buffer pointer check */
    (size <= 0)				/* buffer size check */
 ) {
    return(0);
 }
 int rvl;				/* return code */
 rvl = 1; 				/* start return code */
 while(1) {
    if(*(buf + 0) == '\0') {		/* empty buffer check */
	u_int8_t cut;			/* string cuting */
	cut = 0;			/* catting clear */ 
	while(1) {
	    if(ustc_read(buf, size, &cut) == 0) {
		return(rvl);
	    }
	    if(*(buf + 0) == '\0') {	/* empty buffer check */
		{ continue; }		/* next file line read */
	    } else {
		{ break; }		/* string readed -> loop exit */
	    }
	}
    }
    int pos;				/* buffer position */
    pos = 0;				/* start buffer position */
    if(*(buf + 0) == '#') {		/* comment line */
	*(buf + 0) = '\0';		/* buffer clear */
	{ continue; }			/* next read */
    }
    USTC_LIB_COMP ulci;			/* kicad lib comp item */
    if(ustc_lib_comp_clear(&ulci) == 0) { /* kicad lib comp clear */
	ustc_error("CAD LIB comp element clear error\r\n");
	return(0);
    }
    if(ustc_cmp(buf,"DEF", &pos) > 0) {
	u_int8_t name[128];		/* name buffer */
	u_int8_t cut;			/* name cuting */
	u_int8_t srd;			/* string reading */
	cut = 0;			/* clear name cuting */
	srd = 0;			/* readed value */
	if(ustc_str(buf, name, size, &pos, &cut, &srd) == 0) {
    	    ustc_error("Error read KICAD LIB comp name {%s}\r\n", 
		buf + pos
	    );
	    return(0);
	} else {
	    if(srd == 0) {
    		ustc_error("Error read KICAD LIB comp {%s} name\r\n", 
		    buf
		);
		return(0);
	    } else {
		int len;		/* component name length */
		len = strlen((char *) name) + 1; /* cad component name length calculate */
		ulci.name = (u_int8_t *) malloc(len); /* cad component name allocate */
		if(ulci.name == 0) {	/* cad component name allocation check */
    		    ustc_error("KICAD LIB comp name {%s} allocation error\r\n", 
			name		/* comp name */	
		    );
		    return(0);
		} else {
		    snprintf(		/* cad component name form */
			(char *) ulci.name, /* comp buffer */
			len,		/* buffer length */
			"%s",		/* format */
			name		/* kicad comp name */
		    );
		}
	    }
	}
	cut = 0;			/* clear name cuting */
	srd = 0;			/* readed value */
	if(ustc_str(buf, name, size, &pos, &cut, &srd) == 0) {
    	    ustc_error("Error read KICAD LIB comp reference {%s}\r\n", 
		buf + pos
	    );
	    return(0);
	} else {
	    if(srd == 0) {		/* string reading check */
    		ustc_error("Error read KICAD LIB comp {%s} reference\r\n", 
		    buf
		);
		return(0);
	    } else {
		int len;		/* reference length */
		len = strlen((char *) name) + 1; /* reference length calculate */
		ulci.reference = (u_int8_t *) malloc(len); /* reference buffer allocate */
		if(ulci.reference == 0) { /* reference pointer check */	
    		    ustc_error("KICAD LIB comp reference {%s} allocation error\r\n", 
			name		/* comp name */	
		    );
		    return(0);
		} else {
		    snprintf(
			(char *) ulci.reference, /* comp buffer */
			len,		/* buffer length */
			"%s",		/* format */
			name		/* comp name */
		    );
		}
	    }
	}
	u_int8_t ird;			/* integer readed */
	int ival;			/* integer value */
        ival = 0;			/* integer value clear */
	ird = 0;			/* readed clear */
	if(ustc_int(buf,&ival,&pos,&ird) == 0) {
	    ustc_error("KICAD LIB comp unused read error\r\n");
	    return(0);
	} else {
	    if(ird != 0) {
    		ulci.unused = ival;	/* kicad lib comp unused write */
	    } else {
    		ulci.unused = 0;	/* kicad lib com unused clear */
	    }
	}
        ival = 0;			/* integer value clear */
	ird = 0;			/* readed clear */
	if(ustc_int(buf,&ival,&pos,&ird) == 0) {
	    ustc_error("KICAD LIB comp text offset read error\r\n");
	    return(0);
	} else {
	    if(ird != 0) {
    		ulci.offset = ival;	/* kicad lib comp text offset write */
	    } else {
    		ulci.offset = 0;	/* kicad lib com text offset clear */
	    }
	}
	cut = 0;			/* clear name cuting */
	srd = 0;			/* readed value */
	if(ustc_str(buf, name, size, &pos, &cut, &srd) == 0) {
    	    ustc_error("Error read KICAD LIB comp pin number visible {%s}\r\n", 
		buf + pos
	    );
	    return(0);
	} else {
	    if(strcmp((char *)name, "Y") == 0) { 
    		ulci.pinnumvis = 1;	/* pin number visible set */
	    } else {
    		ulci.pinnumvis = 0;	/* pin number invisible */
	    }
	}
	cut = 0;			/* clear name cuting */
	srd = 0;			/* readed value */
	if(ustc_str(buf, name, size, &pos, &cut, &srd) == 0) {
    	    ustc_error("Error read KICAD LIB comp pin name visible {%s}\r\n", 
		buf + pos
	    );
	    return(0);
	} else {
	    if(strcmp((char *)name, "Y") == 0) {
    		ulci.pinnamvis = 1;	/* pin name visible set */
	    } else {
    		ulci.pinnamvis = 0;	/* pin name invisible */
	    }
	}
	ird = 0;			/* readed clear */
	if(ustc_int(buf,&ival,&pos,&ird) == 0) {
	    ustc_error("KICAD LIB comp x0 position read\r\n");
	    return(0);
	} else {
	    if(ird != 0) {
    		ulci.units = ival;	/* units write */
	    } else {
    		ulci.units = 0;		/* units clear */
	    }
	}
	cut = 0;			/* clear name cuting */
	srd = 0;			/* readed value */
	if(ustc_str(buf, name, size, &pos, &cut, &srd) == 0) {
    	    ustc_error("Error read KICAD LIB comp unit locked {%s}\r\n", 
		buf + pos
	    );
	    return(0);
	} else {
	    if(strcmp((char *)name, "F") == 0) { /* unit swapable check */
		ulci.unitlock = USTC_LIB_COMP_UNITLOCK_FIX; /* unit swapable */
	    } else 
	    if(strcmp((char *)name, "L") == 0) { /* unit lock check */
		ulci.unitlock = USTC_LIB_COMP_UNITLOCK_LOCK; /* unit lock or swap disable */
	    } else
	    if(strcmp((char *)name, "0") == 0) { /* unit swapable old notation check */
		ulci.unitlock = USTC_LIB_COMP_UNITLOCK_FIXOLD;
	    } else {
		ulci.unitlock = USTC_LIB_COMP_UNITLOCK_FIXOLD;	/* unit lock or swap enable */
	    }
	}
	cut = 0;			/* clear name cuting */
	srd = 0;			/* readed value */
	if(ustc_str(buf, name, size, &pos, &cut, &srd) == 0) {
    	    ustc_error("Error read KICAD LIB comp power {%s}\r\n", 
		buf + pos
	    );
	    return(0);
	} else {
	    if(strcmp((char *)name, "P") == 0) {
		ulci.power = 1;	/* power component */
	    } else {
		ulci.power = 0;	/* normal component */
	    }
	}
    }
    *(buf + 0) = '\0';			/* buffer clear */
    while(1) {
	if(*(buf + 0) == '\0') {	/* empty buffer check */
	    u_int8_t cut;		/* string cuting */
	    cut = 0;			/* catting clear */ 
	    while(1) {
		if(ustc_read(buf, size, &cut) == 0) {
		    ustc_error("KICAD LIB component comp element read error\r\n");
		    return(0);
		}
		if(*(buf + 0) == '\0') { /* empty buffer check */
		    { continue; }	/* next file line read */
		} else {
		    { break; }		/* string readed -> loop exit */
		}
	    }
	}
	if(*(buf + 0) == '\0') {	/* buffer check */
	    { break; }
	}
	pos = 0;
	if(ustc_cmp(buf,"ALIAS", &pos) > 0) {
	    ulci.alias = *alnum;	/* alias reference */
	    if(ustc_lib_alias_read(	/* alias read */
		alnum,			/* alias number pointer */
		buf,			/* buffer */
	        size			/* buffer size */
	    ) == 0) {
		if(rvl == 1) {
    	    	    ustc_error("Error read KICAD LIB alias {%s}\r\n", 
	    		buf + pos
		    );
		}
		return(0);
	    }
	    ulci.alcount = (*alnum - ulci.alias); /* alias count calculate */
	    *(buf + 0) = '\0';		/* buffer clear */
	} else 
	if(*(buf + pos) == 'F') {
	    USTC_LIB_FIELD ulfi;	/* lib field */
	    if(ustc_lib_field_clear(&ulfi) == 0) { /* field clear */
		if(rvl == 1) {
    	    	    ustc_error("KICAD LIB field clear \r\n");
		}
		return(0);
	    }
	    pos += 1;
	    u_int8_t fidx;		/* field index */
	    fidx = 0;			/* field index check */
	    if(ustc_lib_field_read(	/* field read */
		&fidx,			/* field index pointer */
		&ulfi,			/* field pointer */
	        buf,			/* buffer */
		size			/* buffer size */
	    ) == 0) {
		if(rvl == 1) {
    	    	    ustc_error("KICAD LIB field read error {%s}\r\n",
			buf
		    );
		}
		return(0);
	    }
	    u_int32_t fref;		/* field reference */
	    fref = *flnum;		/* field reference write */
	    if(ustc_lib_field_add(	/* field add */
		flnum,			/* field number pointer */
		&ulfi			/* field */
	    ) == 0) {
		if(rvl == 1) {
    	    	    ustc_error("KICAD LIB field add error\r\n");
		}
		return(0);
	    }
	    if(fidx == 0) {
		ulci.ref = fref;	/* field reference write */
	    } else
	    if(fidx == 1) {
		ulci.val = fref;	/* field value write */
	    } else
	    if(fidx == 2) {
		ulci.pcb = fref;	/* field pcb footprint write */
	    } else
	    if(fidx == 3) {
		ulci.diagram = fref;	/* field diagram write */
	    } else {
		if(ulci.fcount == 0) {	/* field count */
		    ulci.field = fref;	/* field reference */
		}    
		ulci.fcount += 1;	/* field count calculate */
	    }
	    *(buf + 0) = '\0';		/* buffer clear */
	} else 
	if(ustc_cmp(buf,"X", &pos) > 0) {
	    ulci.pin = *pnnum;		/* pin reference */
	    if(ustc_lib_pin_read(	/* pin read */
		pnnum,			/* pin number pointer */
	        buf,			/* buffer */
		size			/* buffer size */
	    ) == 0) {
		if(rvl == 1) {
    		    ustc_error("KICAD LIB field pin read error\r\n");
		}
		return(0);
	    }
	    ulci.pcount = (*pnnum - ulci.pin); /* pin count calculate */
	    *(buf + 0) = '\0';		/* buffer clear */
	} else
	if(ustc_cmp(buf,"DRAW", &pos) > 0) {
	    *(buf + 0) = '\0';		/* buffer clear */
	    ulci.draw = *drnum;		/* pin reference */
	    if(ustc_lib_draw_read(	/* draw read */
		drnum,			/* draw number pointer */
		plnum,			/* poly number pointer */
		rcnum,			/* rectangle number pointer */
		rngnum,			/* ring number pointer */
		arnum,			/* arc number pointer */
		txnum,			/* text number pointer */
		buf,			/* buffer */
		size			/* buffer size */
	    ) == 0) {
		if(rvl == 1) {
    		    ustc_error("KICAD LIB field pin draw read error\r\n");
		}
		return(0);
	    }
	    ulci.dcount = (*drnum - ulci.draw);  /* draw element count */
	} else
	if(ustc_cmp(buf,"ENDDRAW", &pos) > 0) {
	    *(buf + pos) = '\0'; 
	} else
	if(ustc_cmp(buf,"ENDDEF", &pos) > 0) {
	    if(ustc_lib_comp_add(	/* component add */
		cnum, 			/* comp number pointer */
		&ulci			/* comp information */
	    ) == 0) {
		ustc_error("KICAD LIB comp add error\r\n");
		return(0);
	    }
	    *(buf + 0) = '\0';		/* read next file line */
	    { break; }
	} else {
	    ustc_error(
		"Wait KICAD LIB comp, X or ENDRAW, readed {%s}\r\n",
		buf + pos
	    );
	    return(0);
	}
    }
 }
 return(rvl);
}
int ustc_lib_free(void)
{
 int rvl;
 rvl = 1;
 if(ustc_lib_header_free(& ustc_lib_header) == 0) {
    rvl = 0;
 }
 if(ustc_lib_alias_free() == 0) {	/* cad alias free */
    rvl = 0;
 }
 if(ustc_lib_field_free() == 0) {	/* cad field free */
    rvl = 0;
 }
 if(ustc_lib_poly_free() == 0) {	/* free lib poly */
    rvl = 0;
 }
 if(ustc_lib_rect_free() == 0) {	/* free lib rect */
    rvl = 0;
 }
 if(ustc_lib_ring_free() == 0) {	/* free lib ring */
    rvl = 0;
 }
 if(ustc_lib_arc_free() == 0) {		/* free lib arc */
    rvl = 0;
 }
 if(ustc_lib_text_free() == 0) {	/* free lib text */
    rvl = 0;
 }
 if(ustc_lib_draw_free() == 0) {	/* free lib draw */
    rvl = 0;
 }
 if(ustc_lib_pin_free() == 0) {		/* free lib pin */ 
    rvl = 0;
 }
 if(ustc_lib_comp_free() == 0) {	/* free lib comp */
    rvl = 0;
 }
 return(rvl);
}
