#ifndef __USTCPDSN_HPP__
#define __USTCPDSN_HPP__
#include <sys/types.h>			/* */
#include <stdio.h>			/* */
/*
License agreement:
USTCPDSN 0.1 (c) 2006-2010 Dmitriy I.Cherkashin, www.ucrouter.ru
email: dch@ucrouter.ru , divch@users.sourceforge.net , dch@ucrouter.com
phone: +8-909-936-8809; ICQ: 474-363-900;
This program is free software with source codes
downloadable via internation communicational net.
If you have source codes of this software original or modified,
you must provide ability to free receive original source codes
of this software to another users even in internation communicational
net absense without any unusual additional payment exept
downloading files from internation communicational net cost or
mail cost.
*/
/*
 ,  : 
USTCPDSN 0.1 (c) 2006-2010  ., www.ucrouter.ru
 : dch@ucrouter.ru,divch@users.sourceforge.net,dch@ucrouter.com
: +8-909-936-8809; ICQ: 474-363-900;
     
      
 .
       
  ,     
     
     
      
       
    
     .
*/
typedef struct {
    u_int8_t * name;			/* component reference */
    u_int8_t * footprint;		/* component footprint */
} USTC_PADSNET_COMP;			/* padsnet component */
extern USTC_PADSNET_COMP * ustc_padsnet_comp; /* padsnet component buffer */
extern u_int32_t ustc_padsnet_comp_count; /* padsnet component count */
typedef struct {
    u_int8_t type;			/* padsnet node reference type */
#define USTC_PADSNET_NODE_NAME_TEXT 0x1	/* text reference */
#define USTC_PADSNET_NODE_NAME_NUM  0x2 /* number reference */
#define USTC_PADSNET_NODE_PIN_TEXT  0x4 /* pin reference */
#define USTC_PADSNET_NODE_PIN_NUM   0x8 /* number reference */
    union {
	u_int8_t * text;		/* component reference text pointer */
	u_int32_t num;			/* component number */
    } name;
    union {
	u_int8_t * text;		/* pin name */
	u_int32_t num;			/* pin number */
    } pin;
} USTC_PADSNET_NODE;
extern USTC_PADSNET_NODE * ustc_padsnet_node; /* padsnet node buffer */
extern u_int32_t ustc_padsnet_node_count;	/* padsnet node count */
typedef struct {
    u_int8_t * name;			/* padsnet signal name */
    u_int32_t node;			/* padsnet node number */
    u_int32_t ncount;			/* padsnet node count */
} USTC_PADSNET_SIGNAL;			/* padsnet signal */
extern USTC_PADSNET_SIGNAL * ustc_padsnet_signal;
extern u_int32_t ustc_padsnet_signal_count;
extern int ustc_padsnet_comp_clear(USTC_PADSNET_COMP * upnci);
extern int ustc_padsnet_node_clear(USTC_PADSNET_NODE * upnni);
extern int ustc_padsnet_signal_clear(USTC_PADSNET_SIGNAL * upnsi);
extern int ustc_padsnet_comp_print(USTC_PADSNET_COMP * upnci); /* pads net component print */
extern int ustc_padsnet_node_print(USTC_PADSNET_NODE * upnni);
extern int ustc_padsnet_signal_print(USTC_PADSNET_SIGNAL * upnsi);
extern int ustc_padsnet_print(void);	/* pads net print */
extern int ustc_padsnet_comp_alloc(u_int32_t count); /* padsnet componet alloc */
extern int ustc_padsnet_comp_add(u_int32_t *cnum, u_int8_t * name, u_int8_t * footprint);
extern int ustc_padsnet_comp_free(void); /* padsnet component free */
extern int ustc_padsnet_comp_num(u_int8_t * cnam); /* return component number */
extern int ustc_padsnet_comp_read(u_int32_t * cnum, u_int8_t * buf, u_int32_t size);
extern int ustc_padsnet_node_alloc(u_int32_t count); /* padsnet node alloc */
extern int ustc_padsnet_node_add(u_int32_t *nnum, u_int8_t * cname, u_int32_t cnum,
	u_int8_t * pname, u_int32_t pnum);
extern int ustc_padsnet_node_free(void); /* padsnet node free */
extern int ustc_padsnet_signal_alloc(u_int32_t count); /* padsnet signal alloc */
extern int ustc_padsnet_signal_add(u_int32_t *snum, USTC_PADSNET_SIGNAL * upnsi);
extern int ustc_padsnet_signal_free(void); /* padsnet signal free */
extern int ustc_padsnet_free(void);
extern int ustc_padsnet_signal_read(u_int32_t * snum, u_int32_t * nnum, 
	u_int8_t * buf, u_int32_t size);
extern int ustc_padsnet_read(void);
#endif 							/* __USTCPDSN_HPP__ */
