#ifndef __USTCIO_HPP__
#define __USTCIO_HPP__
#include <sys/types.h>			/* */
#include <stdio.h>			/* */
/*
License agreement:
USTC 0.1 (c) 2006-2010 Dmitriy I.Cherkashin, www.ucrouter.ru
email: dch@ucrouter.ru , divch@users.sourceforge.net , dch@ucrouter.com
phone: +8-909-936-8809; ICQ: 474-363-900;
This program is free software with source codes
downloadable via internation communicational net.
If you have source codes of this software original or modified,
you must provide ability to free receive original source codes
of this software to another users even in internation communicational
net absense without any unusual additional payment exept
downloading files from internation communicational net cost or
mail cost.
*/
/*
 ,  : 
USTC 0.1 (c) 2006-2010  ., www.ucrouter.ru
 : dch@ucrouter.ru,divch@users.sourceforge.net,dch@ucrouter.com
: +8-909-936-8809; ICQ: 474-363-900;
     
      
 .
       
  ,     
     
     
      
       
    
     .
*/
extern FILE * ustc_fi;			/* input file descriptor */
extern FILE * ustc_fo;			/* output file descriptor */
#ifdef  __USTC_DEBUG__
extern u_int8_t ustc_debug_mode;
#endif 							/* __USTC_DEBUG__ */
/* output functions */
extern int ustc_error(const char *frmt, ...);
extern int ustc_debug(const char *frmt, ...); 
extern int ustc_printf( const char *frmt, ... );
/* file/string read functions */
extern int ustc_read(void * buf, int len, u_int8_t * cut);
extern int ustc_cmp(void * buf, char * str, int *spos);
extern int ustc_ncmp(void * buf, char * str, int *spos, int count, int unsen);
extern int ustc_str(void * buf, u_int8_t * str, int len, int *spos, u_int8_t *cut, u_int8_t * srd);
extern int ustc_int(void * buf, int * ival, int * ipos, u_int8_t *ird);
extern int ustc_xint(void * buf, u_int32_t * uval, int * upos, u_int8_t *urd);
extern int ustc_double(void * buf, double * dval, int * dpos, u_int8_t *drd);
extern int ustc_space(void * buf); /* check space in null terminating string */
typedef struct {
 u_int8_t * name;			/* layer name */
 int num;				/* layer number */
} USTC_LAYER;
extern USTC_LAYER * ustc_layer;
extern u_int32_t ustc_layer_count;
extern int ustc_layer_clear(USTC_LAYER * uli);
extern int ustc_layers_print(void);
extern int ustc_layer_alloc(u_int32_t count);
extern int ustc_layer_add(u_int32_t *lnum, u_int8_t * nam, int tnum);
extern int ustc_layer_free(void);
extern int ustc_layer_num(u_int8_t * name);
#endif 							/* __USTCIO_HPP__ */
